'Grid-specific code for DDT ListView by Gary Beene

Type CustomColors
   c(15) As Long
End Type

Enum gbGridEquates Singular
   IDC_ListViewG  = 20000

   IDX_Right
   IDX_Down
   IDX_Up
   IDX_Left
   IDX_Row
   IDX_Col
   IDX_Ok
   IDX_Cancel

   IDE_ListView
   IDE_TextBox
   IDE_ExitSave
   IDE_UpdateNext
   IDE_Clear
   IDE_Graphic

   IDM_gridCutT
   IDM_gridCopyT
   IDM_gridDeleteT
   IDM_gridPasteT
   IDM_gridSelectImageT

   IDM_gridEditInplace

   IDM_gridUnselect

   IDM_gridInsertRow
   IDM_gridDeleteRow
   IDM_gridRestoreOrder

   IDM_gridDeleteCol
   IDM_gridInsertCol
   IDM_gridSetHeaderText
   IDM_gridEditDialog

   IDM_gridMoveRowUp
   IDM_gridMoveRowDown

   IDM_gridEdit
   IDM_gridJump
   IDM_gridVisible
   IDM_gridSep

   IDS_FindThisLabel = 5000
   IDS_FindThis
   IDS_Replace
   IDS_ReplaceAll
   IDS_SearchNext
   IDS_SearchPrevious
   IDS_CaseSensitive

   EditInPlace = 0
   EditFixed
   EditDialog

   IconAsc = 0
   IconDesc
   IconNone

   XLeft = 1
   XRight
   XUp
   XDown
   XRow
   XCol
End Enum

'Handles - Working variables
Global hDlgG,hTextBoxIP,hTextBoxF,hHeaderG,ghHook    As Dword
Global hContextLV,hContextHdr,hContextTB,hFontG      As Dword
Global hDlgS,hDlgE,hListViewG,hBMP,hGraphicE,hBMPE   As Dword

'Working Variables
Global MaxRow, MaxCol,OrigLVProc,OrigTBProc          As Long
Global CurrentRow                                    As Long
Global SearchDialogShown                             As Long
Global ContextHeader,SearchDirectionD                As Long
Global tempD(),tempE()                               As String
Global imgWE, imgHE, TrueImageSize                   As Long

'INI Variables
Global CustomColorList                               As CustomColors
Global EditInPlace                                   As Long
Global FontSize,FontAttr                             As Long
Global FontName,FindThis                             As WStringZ * %Max_Path
Global ColWidths,SortOrder                           As WStringZ * %Max_Path
Global ELeft,ETop,EWidth,EHeight,ETopTB              As Long

Sub gbGrid_Destroy
   ListView Get Select hDlgG, %IDC_ListViewG To CurrentRow
   Decr CurrentRow
   gbGrid_GetColWidths
   SetWindowLong hListViewG, %GWL_WNDPROC, OrigLVProc
   SetWindowLong hTextBoxIP, %GWL_WNDPROC, OrigTBProc
   SetWindowLong hTextBoxF,  %GWL_WNDPROC, OrigTBProc
End Sub

Sub gbGrid_GetColWidths
   Local i,w As Long
   ColWidths = ""
   For i = 1 To MaxCol
      ListView Get Column hDlgG, %IDC_ListViewG,i To w
      ColWidths += Str$(w) + "|"
   Next i
End Sub

Sub gbGrid_ApplyColWidths
   Local i As Long
   For i = 1 To MaxCol
      ListView Set Column hDlgG, %IDC_ListVIewG, i, Val(Parse$(ColWidths,"|",i))
   Next i
End Sub

Sub gbGrid_CreateContextMenus
   'Header context menu
   Menu New PopUp To hContextHdr
   Menu Add String, hContextHdr, "Insert Col", %IDM_gridInsertCol, %MF_Enabled
   Menu Add String, hContextHdr, "Delete Col", %IDM_gridDeleteCol, %MF_Enabled
   Menu Add String, hContextHdr, "Set Header Text", %IDM_gridSetHeaderText, %MF_Enabled

   'ListView Context menu
   Menu New PopUp To hContextLV
   Menu Add String, hContextLV, "Insert Row", %IDM_gridInsertRow, %MF_Enabled
   Menu Add String, hContextLV, "Delete Row", %IDM_gridDeleteRow, %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextLV, "Move Row Up", %IDM_gridMoveRowUp, %MF_Enabled
   Menu Add String, hContextLV, "Move Row Down", %IDM_gridMoveRowDown, %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextLV, "Restore Original Order", %IDM_gridRestoreOrder, %MF_Enabled

   'TextBox context menu
   Menu New PopUp To hContextTB
   Menu Add String, hContextTB, "Copy",   %IDM_gridCopyT,  %MF_Enabled
   Menu Add String, hContextTB, "Cut",    %IDM_gridCutT,  %MF_Enabled
   Menu Add String, hContextTB, "Paste",  %IDM_gridPasteT,  %MF_Enabled
   Menu Add String, hContextTB, "Delete", %IDM_gridDeleteT,  %MF_Enabled
   Menu Add String, hContextTB, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextTB, "Select Image", %IDM_gridSelectImageT,  %MF_Enabled
End Sub

Sub gbGrid_GetDispInfo(lParam As Long)
   Local iRow,iCol As Long, tmp$$
   Local pLVDI As LV_DISPINFOW Ptr
   pLVDI = LParam                'pointer to LVDISPINFO structure for requested subitem
   iRow = @pLVDI.item.iItem+1       'row being asked for D() is 1-based
   iCol = @pLVDI.item.iSubItem+1    'sub item being asked for (columns) D() is 1-based
   tmp$$ = D(iCol,DX(iRow))
   @pLVDI.item.pszText = StrPtr(tmp$$) 'text sent to ListView
End Sub

Sub gbGrid_Edit(InPlaceFlag As Long)
   gbGrid_DisplayEditDialog
End Sub

Sub gbGrid_IDOK
   Select Case GetFocus
      Case hListViewG
         gbGrid_Edit 0
   End Select
End Sub

Sub gbGrid_Jump
   Local pt As Point, temp$
   Dialog Get Loc hDlgG To pt.x, pt.y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(gbGrid_InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "GoTo Row:", Str$(CurrentRow+1), pt.x+100,pt.y+100)
   UnhookWindowsHookEx ghHook
   If Len(Trim$(temp$)) Then
      CurrentRow = Max(0,Min(Val(temp$),MaxRow-1)) - 1
      ListView Select hDlgG, %IDC_ListViewG, CurrentRow + 1
       ListView_SetItemState GetDlgItem(hDlg, %IDC_ListViewG), CurrentRow, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
      gbGrid_UpdateTextBoxAndStatusbar
      gbGrid_EnsureVisibleCell CurrentRow
   End If
End Sub

Sub gbGrid_EnsureVisibleCell(tRow As Long)
    'ensure row is visible
    ListView Visible hDlgG, %IDC_ListViewG, tRow+1
End Sub

Sub gbGrid_UpdateTextBoxAndStatusbar
   Statusbar Set Text hDlgG, %IDC_StatusBar, 1, 0, "  Row: " + Format$(CurrentRow+1,"#,###,##0") + " of " + Format$(MaxRow,"#,###,##0")
   Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, gbGrid_STitles
End Sub

Sub gbGrid_CreateStatusBar
   Control Add Statusbar, hdlg, %IDC_StatusBar, "", 0,0,0,0
   Statusbar Set Parts hDlg, %IDC_StatusBar, 150,250,99999
End Sub

Function gbGrid_InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr, iStyle As Long
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam : cst = @cw.lpcs                ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then
         Select Case @cst.hMenu
            Case %IdOk   :   @cst.x=20:@cst.y=45:@cst.cx=60
            Case %IdCancel : @cst.x=110:@cst.y=45:@cst.cx=60
         End Select
      End If
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400  'prompt moved out of the way
      If UCase$(szTemp) = "EDIT"   Then
         @cst.x = 10   : @cst.y = 10 : @cst.cx = 175 : @cst.cy = 30
         iStyle = GetWindowLong(wParam,%GWL_Style)
         SetWindowLong wparam, %GWL_Style, iStyle 'Or %ES_Password
      End If
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = 100  'dialog
   End If
End Function

Sub gbGrid_CreateListView
   Local hImageList As Dword, w,h As Long
   Dialog Get Client hDlgG To w,h
   Control Kill hDlgG, %IDC_ListViewG
'   Control Add ListView, hDlgG, %IDC_ListViewG,"", 10,60,w-20,h-70,  %WS_TabStop Or %WS_Visible Or %LVS_Report Or %LVS_OwnerData Or %LVS_SingleSel Or %LVS_ShowSelAlways, %WS_Ex_ClientEdge
   Control Add ListView, hDlgG, %IDC_ListViewG,"", 10,60,0,0,  %WS_TabStop Or %WS_Visible Or %LVS_Report Or %LVS_OwnerData Or %LVS_SingleSel Or %LVS_ShowSelAlways, %WS_Ex_ClientEdge
   Control Handle hDlgG, %IDC_ListViewG To hListViewG
   ListView Set StyleXX hDlgG, %IDC_ListViewG, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
   OrigLVProc = SetWindowLong(hListViewG, %GWL_WndProc, CodePtr(gbGrid_LVProc))  'subclass LV
   hHeaderG = ListView_GetHeader(hListViewG)
   'create imagelist
   ImageList New Icon 16,16,24,2 To hImageList
   ImageList Add Icon hImageList, "xup"        'ascending
   ImageList Add Icon hImageList, "xdown"      'descending
   'assign imagelist to header
   hHeaderG = ListView_GetHeader(hListViewG)
   Header_SetImageList hHeaderG, hImagelist
End Sub

Sub gbGrid_CreateFakeData
   Local i,j As Long
   MaxRow = 1000  : MaxCol = 9
   ReDim D(1 To MaxCol,1 To MaxRow)
   ReDim DX(MaxRow)
   ReDim Headers(1 To MaxCol)
   Array Assign Headers() = "Random", "Words", "From", "The", "Constitution", "of", "the", "United", "States"
   'read in words from the constitution
   Open "files\wordlist.txt" For Input As #1
   FileScan #1, Records To i
   Dim Words(i-1) As String
   Line Input #1, Words()
   Close #1
   Randomize Timer
   For i = 1 To MaxCol
      For j = 1  To MaxRow
         D(i,j) = Words(Rnd(0,UBound(Words)))
      Next j
   Next i
End Sub

Function gbGrid_NewTBProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTB, %TPM_LeftAlign, x, y, 0, hDlgG, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OrigTBProc, hWnd, Msg, wParam, lParam)
End Function

Function gbGrid_Font() As Long
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(gbGrid_FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlgG, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      gbGrid_CreateFont
   End If
End Function

Function gbGrid_FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
   End If
End Function

Function gbGrid_LVProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long, pt As Point, rc As Rect
   Select Case Msg
      Case %WM_ContextMenu
         GetWindowRect hHeaderG, rc
         pt.x = Lo(Integer,LParam) : pt.y = Hi(Integer, LParam)  'WM_ContextMenu returns xy coordinates of mouse
         ScreenToClient hListViewG, pt
         If Hi(Integer, LParam) < rc.nBottom Then  'is over header
            ContextHeader = gbGrid_GetContextHeader(pt) + 1
            x = Lo(Integer,LParam) : y = Hi(Integer, LParam)    'WM_ContextMenu returns xy coordinates of mouse
            TrackPopupMenu hContextHdr, %TPM_LeftAlign, x, y, 0, hDlgG, ByVal 0   'put context menu where mouse is
            Function = 0 : Exit Function
         Else               'is not over header
            x = Lo(Integer,LParam) : y = Hi(Integer, LParam)    'WM_ContextMenu returns xy coordinates of mouse
            TrackPopupMenu hContextLV, %TPM_LeftAlign, x, y, 0, hDlgG, ByVal 0   'put context menu where mouse is
            Function = 0 : Exit Function
         End If

      Case %WM_KeyDown
         Select Case wParam
            Case %VK_Return : gbGrid_Edit(0)
        End Select
   End Select
   Function = CallWindowProc(OrigLVProc, hWnd, Msg, wParam, lParam)
End Function

Sub gbGrid_SetHeaderText
   Local pHdi As HDItem, tempZ As WStringZ * 30, x,y,iCol As Long
   FileDirty = 1
   'get iCol
   iCol = ContextHeader+1
   'ask user for new header title
   Dialog Get Loc hDlgG To x,y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(gbGrid_InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   tempZ = InputBox$("", "Enter Header Title:", Headers(iCol), x+100, y+100)
   UnhookWindowsHookEx ghHook
   If Len(tempZ) Then
      pHdi.mask    = %HDI_Text
      pHdi.pszText = VarPtr(tempZ)
      Header_SetItem hHeaderG, iCol-1, pHdi
   End If
End Sub

Sub gbGrid_SetHeaderIconOnRight(ByVal iCol As Integer, iImg As Long)
   Local hdi As HD_ITEM
   hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
   hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right
   hdi.iImage = iImg
   Header_SetItem(hHeaderG, iCol-1, hdi)
End Sub

Sub gbGrid_ClearIconOnRight(iCol As Integer)
   Local hdi As HD_ITEM
   hdi.mask = %HDI_FORMAT
   hdi.fmt = %HDF_String
   Header_SetItem(hHeaderG, iCol-1, hdi)
End Sub

Sub gbGrid_ClearAllSortIcons
   Local i As Integer
   For i = 0 To Header_GetItemCount(hHeaderG) - 1
      gbGrid_ClearIconOnRight i+1
   Next
End Sub

Function gbGrid_STitles() As String
   Local i As Long, temp$, tmp$
   If UBound(SO) = -1 Then Exit Function
   For i = 0 To UBound(SO)
      ListView Get Header hDlgG, %IDC_ListViewG, SO(i).col To tmp$
      temp$ += IIf$(SO(i).dir=0," +"," -") + tmp$   'SO().dir  0=asc  1=desc
   Next i
   Function = temp$
End Function

Function gbGrid_CurrentSortDirection(iCol As Long) As Long   'get sort direction SO() element containing iCol
   Local i As Long
   Function = %IconNone
   If UBound(SO) = -1 Then Exit Function
   For i = 0 To UBound(SO)
      If SO(i).col = iCol Then Function = SO(i).dir : Exit Function
   Next i
End Function

Function gbGrid_SOLocation(iCol As Long) As Long  'get SO() element containing iCol
   Local i As Long
   Function = -1
   If UBound(SO) =  -1 Then Exit Function
   For i = 0 To UBound(SO)
      If SO(i).col = iCol Then Function = i : Exit Function
   Next i
End Function

Sub gbGrid_ColumnClick(iCol As Long)
   Local i As Long
   gbGrid_RestoreOriginalOrder
   If (GetAsyncKeyState(%VK_SHIFT) And &H8000) Then
      i = gbGrid_SOLocation(iCol)
      If i = -1 Then
         'iCol is not in SO so add iCol to SO
         i = UBound(SO) + 1
         ReDim Preserve SO(i)
         SO(i).col = iCol
         SO(i).dir = %IconAsc   'when added, always set to %IconASC
         gbGrid_SetHeaderIconOnRight SO(i).col, SO(i).dir  'col,img
         If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()
      Else
         Incr SO(i).dir
         If SO(i).dir > %IconNone Then SO(i).dir = %IconAsc
         gbGrid_SetHeaderIconOnRight SO(i).col, SO(i).dir  'col,img
         If SO(i).dir = %IconNone Then  'remove from array
            If UBound(SO) = 0 Then
               gbGrid_EraseSortOrder
            Else
               Array Delete SO(i)
               ReDim Preserve SO(UBound(SO)-1)
            End If
         End If
         If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()
      End If
   Else
      gbGrid_ClearAllSortIcons
      i = gbGrid_CurrentSortDirection(iCol)
      Select Case i
         Case %IconAsc, %IconNone
            ReDim SO(0)       'going to descending or ascending
            SO(0).col = iCol
            SO(0).dir = IIf(i=%IconAsc,%IconDesc,%IconAsc)
            gbGrid_SetHeaderIconOnRight SO(0).col, SO(0).dir  'col,img
            If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()
         Case %IconDesc
            gbGrid_EraseSortOrder  'going to no icons
      End Select
   End If
   Control ReDraw hDlgG, %IDC_ListViewG
End Sub


Sub gbSearch_DisplaySearchDialog
   Dialog Font "Tahoma",10,0
   Dialog New Pixels, hDlgG, "Find", 100, 100, 340, 70, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hDlgS
   Dialog Set Icon hDlgS, "xsearch"

   Control Add Label, hDlgS, %IDS_FindThisLabel, "Find This:", 5, 10, 80, 20

   'If Len(Sci_GetSelText(hSciTarget)) Then SearchTermD = Sci_GetSelText(hSciTarget)
   Control Add TextBox, hDlgS, %IDS_FindThis, FindThis, 90, 10, 150, 25, %WS_TabStop Or %WS_Border Or %ES_AutoHScroll, %WS_Ex_ClientEdge

   Control Add Button, hDlgS, %IDS_SearchNext, "Find Next", 250, 10, 80, 25
   Control Add Button, hDlgS, %IDS_SearchPrevious, "Find Prev", 250, 40, 80, 25

   Control Add CheckBox, hDlgS, %IDS_CaseSensitive, "Case Sensitive", 10, 40, 100, 20
   Control Set Check hDlgS, %IDS_CaseSensitive, CaseSensitive

   Control Add Button, hDlgS, %IdOk, "Ok", 200, 230, 20, 20
   Control Add Button, hDlgS, %IdCancel, "Cancel", 230, 230, 20, 20
   Control Show State hDlgS, %IdOk, %SW_Hide
   Control Show State hDlgS, %IdCancel, %SW_Hide

   SearchDialogShown = 1
   Dialog Show Modeless hDlgS Call gbSearch_DlgProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop Until SearchDialogShown = 0

End Sub

CallBack Function gbSearch_DlgProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog : SearchDirectionD = 1
      Case %IdCancel      : SearchDialogShown = 0 : Dialog End hDlgS
      Case %WM_Destroy    : SearchDialogShown = 0 : Control Set Focus hDlgG, %IDC_ListViewG
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDS_FindThis   : If Cb.CtlMsg = %EN_Change Then Control Get Text hDlgS, %IDS_FindThis To FindThis
            Case %IDS_CaseSensitive   : Control Get Check hDlgS, %IDS_CaseSensitive To CaseSensitive
            Case %IDS_Replace
'               Replace FindThis With ReplaceWithThis In D(CurrentCol+1,CurrentRow+1)
               gbSearch_FindText
            Case %IdCancel            : SearchDialogShown = 0 : Dialog End hDlgS
            Case %IdOk                : gbSearch_FindText
            Case %IDS_SearchNext      : SearchDirectionD = 1  : gbSearch_FindText         'search forward
            Case %IDS_SearchPrevious  : SearchDirectionD = 0  : gbSearch_FindText         'search backward
         End Select
   End Select
End Function

Function gbSearch_FindText() As Long
   Local i,j,iResult,iRow As Long, sTerm$, mTerm$
   ListView Get Select hDlgG, %IDC_ListViewG To iRow
   sTerm$ = IIf$(CaseSensitive,FindThis,LCase$(FindThis))
   If SearchDirectionD Then
      For i = iRow+1 To MaxRow
         For j = 1 To MaxCol
            mTerm$ = IIf$(CaseSensitive,D(j,i),LCase$(D(j,i)))
            iResult = InStr(mTerm$,sTerm$)
            If iResult Then Exit, Exit
         Next j
      Next i
  Else
      For i = iRow-1 To 1 Step -1
         For j = 1 To MaxCol
            mTerm$ = IIf$(CaseSensitive,D(j,i),LCase$(D(j,i)))
            iResult = InStr(mTerm$,sTerm$)
            If iResult Then Exit, Exit
         Next j
      Next i
  End If

  If iResult Then
     CurrentRow = i-1
     ListView Select hDlgG, %IDC_ListViewG, i
     gbGrid_EnsureVisibleCell CurrentRow
     gbGrid_UpdateTextBoxAndStatusbar
  Else
     If SearchDirectionD = 1 Then gbGrid_MsgBox "Match not found between current position and end of document!", %MB_Ok Or %MB_TaskModal Or %MB_IconExclamation, "Find Text"
     If SearchDirectionD = 0 Then gbGrid_MsgBox "Match not found between current position and beginning of document!", %MB_Ok Or %MB_TaskModal Or %MB_IconExclamation, "Find Text"
  End If
End Function

Sub gbGrid_DeleteCol
   Local i,x,y,SortFlag As Long
   If UBound(D,1) = 1 Then Beep : Exit Sub     'cannot delete last column
   FileDirty = 1

   'create tempD() that does not have the column
   ReDim tempD(1 To UBound(D,1)-1,1 To UBound(D,2))
   For y = 1 To UBound(D,1)          'col
      If y = ContextHeader Then Iterate For
      For x = 1 To UBound(D,2)       'row
         If y < ContextHeader Then tempD(y,x) = D(y,x)
         If y > ContextHeader Then tempD(y-1,x) = D(y,x)
      Next x
   Next y

   'listview
   Decr MaxCol
   ListView Delete Column hDlgG, %IDC_ListViewG, ContextHeader

   'resize D, copy tempD to D
   ListView_SetItemCountEx(hListViewG, 0, %LVSICF_noInvalidateAll) 'max rows
   ReDim D(1 To UBound(tempD,1),1 To UBound(tempD,2))
   For y = 1 To UBound(tempD,1)
      For x = 1 To UBound(tempD,2)
         D(y,x) = tempD(y,x)
      Next x
   Next y
   ListView_SetItemCountEx(hListViewG, UBound(D,2), %LVSICF_noInvalidateAll) 'max rows

   'sort order
   For i = 0 To UBound(SO)
      If SO(i).col = ContextHeader Then
         SortFlag = 1
         gbGrid_ClearIconOnRight((ContextHeader))
         If UBound(SO)>0 Then
            Array Delete SO(i)
            ReDim Preserve SO(UBound(SO)-1)
         Else
            Erase SO()
         End If
         Exit For
      End If
   Next i
   jpGetColTypes D(), UBound(D,1), UBound(D,2)
   If SortFlag And (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()

   'selections
   CurrentRow = 0
   gbGrid_UpdateTextBoxAndStatusbar
   Control Set Focus hDlgG, %IDC_ListViewG
End Sub

Sub gbGrid_InsertCol
   Local i,x,y As Long
   FileDirty = 1

   'create tempD() that does not have the column
   ReDim tempD(1 To UBound(D,1)+1,1 To UBound(D,2))
   For y = 1 To UBound(D,1)
      For x = 1 To UBound(D,2)
         If y < ContextHeader Then tempD(y,x) = D(y,x)
         If y >= ContextHeader Then tempD(y+1,x) = D(y,x)
      Next x
   Next y

   'listview
   Incr MaxCol
   ListView Insert Column hDlgG, %IDC_ListViewG, ContextHeader, "New", 100, 0

   'resize D, copy tempD to D
   ListView_SetItemCountEx(hListViewG, 0, %LVSICF_noInvalidateAll) 'no rows
   ReDim D(1 To UBound(tempD,1),1 To UBound(tempD,2))
   For y = 1 To UBound(tempD,1)
      For x = 1 To UBound(tempD,2)
         D(y,x) = tempD(y,x)
      Next
   Next y
   ListView_SetItemCountEx(hListViewG, UBound(D,2), %LVSICF_noInvalidateAll) 'max rows

   'sort order
   For i = 0 To UBound(SO)
      If SO(i).col >= ContextHeader Then Incr SO(i).col
   Next i
   jpGetColTypes D(), UBound(D,1), UBound(D,2)

   'selections
   gbGrid_UpdateTextBoxAndStatusbar
   Control Set Focus hDlgG, %IDC_ListViewG
End Sub

Function gbGrid_GetContextHeader(pt As Point) As Long
   Local hti As HD_HitTestInfo
   hti.pt = pt
   SendMessage hHeaderG, %hdm_HitTest, 0, VarPtr(hti)     'see what column we are over
   Function = hti.iItem
End Function

Sub gbGrid_MoveRowUp
   Local i,iRow As Long
   ListView Get Select hDlgG, %IDC_ListViewG To iRow
   If iRow = 1 Then Beep : Exit Sub
   For i = 1 To MaxCol
      Swap D(i,DX(iRow)), D(i,DX(iRow-1))
   Next
   gbGrid_Redraw
End Sub

Sub gbGrid_MoveRowDown
   Local i,iRow As Long
   ListView Get Select hDlgG, %IDC_ListViewG To iRow
   If iRow = UBound(D,2) Then Beep : Exit Sub
   For i = 1 To MaxCol
      Swap D(i,DX(iRow)), D(i,DX(iRow+1))
   Next
   gbGrid_Redraw
End Sub

Sub gbGrid_InsertRow
   Local x,y As Long
   FileDirty = 1

   'ReDim D() and DX() and MaxRow
   MaxRow = UBound(D,2) + 1
   ReDim Preserve D(1 To UBound(D,1),1 To MaxRow)
   ReDim Preserve DX(MaxRow)

   'move stuff up one
   For y = 1 To UBound(D,1)
      For x = UBound(D,2) To CurrentRow+2 Step -1
         D(y,x) = D(y,x-1)
      Next y
      D(y,CurrentRow+1) = ""
   Next y

   'resort
   gbGrid_RestoreOriginalOrder
   If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()

   'select currentrow/currentcol
   Control Set Focus hDlgG, %IDC_ListViewG
   ListView_SetItemCountEx(hListViewG, UBound(D,2), %LVSICF_noInvalidateAll) 'max rows
   gbGrid_Redraw
End Sub

Sub gbGrid_DeleteRow
   Local x,y As Long
   FileDirty = 1

   'initialize and exit if required
   If UBound(D,2) = 1 Then Beep : Exit Sub     'cannot delete last row

   'move stuff down one
   For y = 1 To UBound(D,1)
      For x = DX(CurrentRow+1) To UBound(D,2)- 1
         D(y,x) = D(y,x+1)
      Next y
   Next x

   'ReDim D() and DX()
   MaxRow = UBound(D,2)-1
   ListView_SetItemCountEx(hListViewG, MaxRow, %LVSICF_noInvalidateAll) 'max rows
   ReDim Preserve D(1 To UBound(D,1),1 To UBound(D,2)-1)
   ReDim Preserve DX(UBound(D,2))

   'resort
   gbGrid_RestoreOriginalOrder
   If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()

   'new CurrentRow
   CurrentRow = Min(CurrentRow,UBound(D,2)-1)
   ListView Select hDlgG, %IDC_ListViewG, CurrentRow + 1
   Control Set Focus hDlgG, %IDC_ListViewG
   gbGrid_Redraw
End Sub

Sub gbGrid_RestoreOriginalOrder    'restore rows to original order
   Local i As Long
   For i = 1 To UBound(DX) : DX(i) = i : Next i
End Sub

Sub gbGrid_BackupSortOrder
   'Store the current sort order ...  SO() ---> SOTemp()
   Local i As Long
   If UBound(SO) = -1 Then
      Erase SOtemp
   Else
      ReDim SOtemp(UBound(SO))
      For i = 0 To UBound(SO)
         SOtemp(i) = SO(i)
      Next i
   End If
End Sub

Sub gbGrid_BackupSortOrderFromString
   Local i,iCount As Long
   iCount = ParseCount(SortOrder,"|")
   ReDim SOtemp(iCount/2-1)
   For i = 0 To iCount-1 Step 2
      SOtemp(i/2).col = Val(Parse$(SortOrder,"|",i+1))
      SOtemp(i/2).dir = Val(Parse$(SortOrder,"|",i+2))
   Next i
End Sub

Sub gbGrid_RestoreSortOrder
   'SOTemp() --> SO()
   Local i As Long
   If UBound(SOtemp) = -1 Then Exit Sub
   ReDim SO(UBound(SOtemp))
   For i = 0 To UBound(SOtemp) : SO(i) = SOtemp(i) : Next i
   gbGrid_RestoreOriginalOrder
   gbGrid_ClearAllSortIcons
   For i = 0 To UBound(SO)
      gbGrid_SetHeaderIconOnRight SO(i).col, SO(i).dir
   Next i
   If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()
   gbGrid_UpdateTextBoxAndStatusbar
   gbGrid_Redraw
End Sub

Sub gbGrid_RestoreOriginalOrderTop
   Erase SO()
   gbGrid_ClearAllSortIcons
   gbGrid_RestoreOriginalOrder
   gbGrid_UpdateTextBoxAndStatusbar
   gbGrid_Redraw
End Sub

Sub gbgrid_Redraw
   Control ReDraw hDlgG, %IDC_ListViewG
End Sub

Sub gbGrid_LockSort
   Local x,y As Long
   FileDirty = 1
   ReDim tempD(1 To UBound(D,1),1 To UBound(D,2))
   'build temp array
   For x = 1 To UBound(D,2)
      For y = 1 To UBound(D,1)
         tempD(y,x) = D(y,DX(x))
      Next y
   Next x
   'put temp array back into main array
   For x = 1 To UBound(D,2)
      For y = 1 To UBound(D,1)
         D(y,x) = tempD(y,x)
      Next y
   Next x
   gbGrid_ClearAllSortIcons
   gbGrid_RestoreOriginalOrder
   Erase SO()
End Sub

Sub gbGrid_CreateFont
   Font New FontName, FontSize, FontAttr To hFontG
   Graphic Set Font hFontG
   Control Set Font hDlgG, %IDC_ListViewG, hFontG
End Sub

Sub gbGrid_EraseColWidths
   ColWidths = ""
End Sub

Sub gbGrid_Initialize
   Local i As Long
   Graphic Bitmap New 5,5 To hBMP
   Graphic Attach hBMP,0
   For i = 1 To MaxCol : ListView Insert Column hDlgG, %IDC_ListViewG,i,Headers(i),75,0 : Next i
   gbGrid_RestoreOriginalOrder
   ListView_SetItemCountEx(hListViewG, UBound(D,2), %LVSICF_noInvalidateAll) 'max rows
   gbGrid_CreateContextMenus
   gbGrid_CreateFont
   jpGetColTypes D(), UBound(D,1), UBound(D,2)  'initialize sort routine
   ListView Select hDlg, %IDC_ListViewG, CurrentRow+1
   ListView_SetItemState GetDlgItem(hDlg, %IDC_ListViewG), CurrentRow, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
End Sub

Sub gbGrid_Report
   Local temp$
   temp$ += "D() (col:row): " + $Tab + Str$(UBound(D,1)) + Str$(UBound(D,2)) + $CrLf
   temp$ += "DX() (rows): " + $Tab + Str$(UBound(DX)) + $CrLf + $CrLf
   temp$ += "File " + IIf$(FileDirty,"Dirty","Not Dirty")
   gbGrid_MsgBox temp$, %MB_Ok + %MB_IconInformation + %MB_TaskModal, "Summary Report"
End Sub

Sub gbGrid_DisplayEditDialog
   Local i,MaxWidth,LVHeight As Long, temp$
   Dialog New Pixels, hDlgG, "Edit Record", ELeft,ETop, EWidth,EHeight, %WS_OverlappedWindow Or %WS_Caption Or %WS_ClipChildren To hDlgE
   Dialog Set Icon hDlgE, "logo"
   Control Add Button, hDlgE, %IDE_Clear,"Clear",340,3,50,20
   Control Add Button, hDlgE, %IDE_UpdateNext,"Update/Next Field",400,3,120,20
   Control Add Button, hDlgE, %IDE_ExitSave,"Exit && Save",500,3,85,20

   LVHeight = ETopTB - 15             'MaxCol * RowHeight + HeaderHeight + 5
   Control Add ListView, hDlgE, %IDE_ListView, "",5,5,300,LVHeight, %WS_TabStop Or %WS_Visible Or %LVS_Report Or %LVS_SingleSel Or %LVS_ShowSelAlways, %WS_Ex_ClientEdge
   ListView Set StyleXX hDlgE, %IDE_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect

   For i = 1 To MaxCol
      MaxWidth = Max(MaxWidth,Graphic(Text.Size.X,Headers(i)))
   Next i

   ListView Insert Column hDlgE,%IDE_ListView,1,"Field",MaxWidth+10,0
   ListView Insert Column hDlgE,%IDE_ListView,2,"Value",9999,0
   For i = 1 To MaxCol : ListView Insert Item hDlgE,%IDE_ListView, i, 0, Headers(i) : Next i

   ReDim tempE(MaxCol)
   For i = 1 To MaxCol
      tempE(i) = D(i,DX(CurrentRow+1))
      Replace $Lf With $CrLf In tempE(i)
      temp$ = Parse$(tempE(i),$CrLf,1) + IIf$(ParseCount(tempE(i),$CrLf)>1," ...","")
      ListView Set Text hDlgE,%IDE_ListView, i, 2, tempE(i)
   Next i
   Control Add Graphic, hDlgE, %IDE_Graphic,"",-5000,-5000,100,100, %WS_Border
   Control Handle hDlgE, %IDE_Graphic To hGraphicE
   Control Add TextBox, hDlgE, %IDE_TextBox, "Value",5,ETopTB,100,100, %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll _
                                          Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop, %WS_Ex_ClientEdge
   OrigTBProc = SetWindowLong(GetDlgITem(hDlgE,%IDE_TextBox), %GWL_WndProc, CodePtr(gbGrid_NewTBProc))  'subclass
   Control Send hDlgE, %IDE_TextBox, %EM_FmtLines, %True, 0
   Control Set Font hDlgE, %IDE_ListView, hFontG
   Control Set Font hDlgE, %IDE_TextBox, hFontG
   Dialog Show Modal hDlgE  Call gbGrid_DlgProc()
End Sub

CallBack Function gbGrid_DlgProc() As Long
   Local EW,EH,iCol,iCount,w As Long, pNMLV As NMListView Ptr, temp$, pt As Point
   Static EditDirty As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         ListView Select hDlgE, %IDE_ListView, 1
         ListView_SetItemState GetDlgItem(hDlgE, %IDE_ListView), 0, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
         Control Set Text hDlgE, %IDE_TextBox, tempE(1)
         Dialog Post hDlgE, %WM_User+500, 0, 0
      Case %WM_User + 500
         Control Set Focus hDlgE, %IDE_ListView
         SendMessage GetDlgItem(hDlgE,%IDE_TextBox), %EM_SetSel, 0, -1
      Case %WM_ContextMenu
         pt.x = Lo(Integer,Cb.LParam) : pt.y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
         ScreenToClient hDlgE, pt
         Control Get Size hDlgE, %IDE_ListView To EW,EH
         If pt.x > EW+5 Then
            Control Set Size hDlgE, %IDE_ListView, EW, pt.y-15
            Control Set Loc hDlgE, %IDE_TextBox, 5, pt.y
            ETopTB = pt.y
            gbGrid_DisplayImage
         End If
      Case %WM_Size
         Dialog Get Client hDlgE To EWidth,EHeight
         Control Get Size hDlgE, %IDE_ListView To EW,EH
         Control Set Size hDlgE, %IDE_ListView,EWidth-15,EH
         Control Set Loc hDlgE, %IDE_Clear, EWidth-290, EHeight-25
         Control Set Loc hDlgE, %IDE_UpdateNext, EWidth-230, EHeight-25
         Control Set Loc hDlgE, %IDE_ExitSave, EWidth-100, EHeight-25
         Control ReDraw hDlgE, %IDE_Clear
         Control ReDraw hDlgE, %IDE_UpdateNext
         Control ReDraw hDlgE, %IDE_ExitSave
         gbGrid_DisplayImage

      Case %WM_SYSCOMMAND      'trap Alt-F4 and X Button
         If ((Cb.WParam And &HFFF0) = %SC_Close) And EditDirty Then    'trap Alt-F4, X-button, WindowMenu/Close
            Select Case gbGrid_MsgBox("Record has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
               Case %IdYes
                  For iCol = 1 To MaxCol
                     Replace $CrLf With $Lf In tempE(iCol)
                     D(iCol,DX(CurrentRow+1)) = tempE(iCol)
                  Next iCol
                  EditDirty = 0   'not really needed, just to show visually what is being done
                  FileDirty = 1
               Case %IdNo
                  EditDirty = 1   'go ahead with closing the application but do not save the results
               Case %IdCancel : Function = 1    'abort the close
            End Select
         End If
      Case %WM_Destroy
         Dialog Get Loc hDlgE To ELeft,ETop
         Dialog Get Client hDlgE To EWidth, EHeight
         Control Get Loc hDlgE, %IDE_TextBox To w,ETopTB
         If EditDirty Then
            For iCol = 1 To MaxCol
               Replace $CrLf With $Lf In tempE(iCol)
               D(iCol,DX(CurrentRow+1)) = tempE(iCol)
            Next iCol
         End If
         SetWindowLong GetDlgItem(hDlgE,%IDE_TextBox), %GWL_WNDPROC, OrigTBProc
         EditDirty = 0
         Control Set Focus hDlgG, %IDC_ListViewG
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel
               If EditDirty Then
                  Select Case gbGrid_MsgBox("Record has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
                     Case %IdYes
                        For iCol = 1 To MaxCol
                           Replace $CrLf With $Lf In tempE(iCol)
                           D(iCol,DX(CurrentRow+1)) = tempE(iCol)
                        Next iCol
                        EditDirty = 0   'not really needed, just to show visually what is being done
                        FileDirty = 1
                        Dialog End hDlgE
                     Case %IdNo
                        EditDirty = 0   'go ahead with closing the application but do not save the results
                        Dialog End hDlgE
                     Case %IdCancel : Function = 1    'abort the close
                  End Select
               Else
                  Dialog End hDlgE
               End If

            Case %IDE_Clear
               Control Set Text hDlgE, %IDE_TextBox, ""
               EditDirty = 1
            Case %IDE_ExitSave
               FileDirty = 1
               Dialog End hDlgE
            Case %IDE_UpdateNext
               ListView Get Select hDlgE, %IDE_ListView To iCol
               Control Get Text hDlgE, %IDE_TextBox To tempE(iCol)
               ListView Set Text hDlgE, %IDE_ListView, iCol, 2, tempE(iCol)
               EditDirty = 1
               ListView Get Count hDlgE, %IDE_ListView To iCount
               Incr iCol
               If iCol > iCount Then iCol = 1
               ListView Select hDlgE, %IDE_ListView, iCol
         End Select
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDE_ListView
               Select Case Cb.NmCode
                  Case %LVN_ItemChanged
                     pNMLV = Cb.LParam
                     If (@pNMLV.uChanged And %LVIF_STATE) = %LVIF_STATE Then  ' if state has changed
                         If (@pNMLV.unewstate And %LVIS_SELECTED) = %LVIS_SELECTED Then
                            ListView Get Select hDlgE, %IDE_ListView To iCol
                            Control Set Text hDlgE, %IDE_TextBox, tempE(iCol)
                            temp$ = LCase$(Right$(tempE(iCol),4))
                            If InStr(".jpg.gif.bmp.png",temp$) Then
                               'fix filename to allow ..\
                               temp$ = tempE(iCol)
                               Replace "..\" With Exe.Path$ In temp$
                               Replace ".\" With Exe.Path$ In temp$
                               If IsFile(temp$) Then gbGrid_LoadImage(temp$)
                            End If
                            gbGrid_DisplayImage
                        End If
                     End If
               End Select
         End Select
   End Select
End Function

Sub  gbGrid_DisplayImage
   Local EW,EH,iCol,x,y,w,h,wNew,hNew,RowHeight As Long, temp$, rc As Rect

   'get needed information
   Control Get Size hDlgE, %IDE_ListView To EW,EH
   Control Send hDlgG, %IDC_ListViewG, %LVM_GetItemRect,0,VarPtr(rc)
   RowHeight = rc.nBottom-rc.nTop + 2
   Control Get Loc hDlgE, %IDE_TextBox To x,y
   w = EWidth-10
   h = EHeight-y-RowHeight-40

   ListView Get Select hDlgE, %IDE_ListView To iCol
   temp$ = tempE(iCol)
   Replace "..\" With Exe.Path$ In temp$
   Replace ".\" With Exe.Path$ In temp$

   If IsFile(temp$) And InStr(".jpg.gif.bmp.png",LCase$(Right$(tempE(iCol),4))) Then
      'handle the textbox
      Control Set Size hDlgE, %IDE_TextBox, EW, RowHeight+5
      If h < 10 Or w < 10 Then Exit If
      'handle the graphic control
      Control Set Loc hDlgE, %IDE_Graphic, x,y+RowHeight+10
      Control Set Size hDlgE, %IDE_Graphic, EW, h
      Graphic Attach hGraphicE, 0
      Graphic Color %rgb_LightGray, %rgb_LightGray
      Graphic Clear
      'copy the image from the hidden memory bitmap to the graphic controlload the image
      If TrueImageSize Then
         Graphic Stretch hBMPE, 0, (0,0)-(imgWE-1,imgHE-1) To (0,0)-(imgWE-1,imgHE-1)  'copy (resized) from memory bitmap to visible image
      Else
         wNew = imgWE / Max(imgWE / w, imgHE / h)
         hNew = imgHE / Max(imgWE / w, imgHE / h)
         x = (w-wNew)/2 : y = (EHeight-y-RowHeight-40-hNew)/2               'upper/left position so resized image is centered
         Graphic Stretch hBMPE, 0, (0,0)-(imgWE-1,imgHE-1) To (x,y)-(x+wNew-1,y+hNew-1)  'copy (resized) from memory bitmap to visible image
      End If
   Else
      Control Set Loc hDlgE, %IDE_Graphic, -5000,-5000
      Control Set Size hDlgE, %IDE_TextBox,EW,EHeight-EH-45
   End If
   Graphic Attach hBMP, 0
End Sub

Sub gbGrid_LoadImage(ByVal ImageFileName As String)
   'load JPG/GIF/PNG image to memory bitmap from file
   Local pImage,pGraphics,hDC As Dword
   Local token As Dword, StartupInput As GdiplusStartupInput

   'initialize GDIPlus
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   'load image/get properties
   GdipLoadImageFromFile((ImageFileName), pImage)  'pImage - image object
   GdipGetImageWidth(pImage,imgWE)                 'get width
   GdipGetImageHeight(pImage,imgHE)                'get height

   'display image in Graphic control
   Graphic Bitmap New imgWE,imgHE To hBMPE
   Graphic Attach hBMPE,0
   Graphic Get DC To hDC                             'hDC is for memory bitmap
   GdipCreateFromHDC(hDC, pGraphics)                 'create graphic object
   GdipDrawImage(pGraphics, pImage, 0,0)             'draw image at 0,0

   'cleanup
   If pImage Then GdipDisposeImage(pImage)           'GDIP cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)   'GDIP cleanup

   'shut downn GDIPlus
   GdiplusShutdown token      ' Shutdown GDI+
End Sub

Function gbGrid_MsgBox(msg$,Flag As Long,caption$) As Long
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(gbGrid_SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
   UnhookWindowsHookEx ghHook
End Function

Function gbGrid_SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   gbGrid_CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub gbGrid_CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x,y,ww,hh As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To ww,hh
   CenterX = x + (ww-BoxX)/2
   CenterY = y + (hh-BoxY)/2
End Sub

Sub gbGrid_FileSafe
   FileDirty = 0
End Sub

Sub gbGrid_CalculateColumnWidths
   Local i,j As Long
   ColWidths = ""
   Dim cWidths(MaxCol) As Long
   For i = 1 To MaxCol
      cWidths(i) = 0
      For j = 1 To MaxRow
         cWidths(i) = Max(cWidths(i),Graphic(Text.Size.X,D(i,j))+15)
      Next j
      cWidths(i) = Max(cWidths(i), Graphic(Text.Size.X,Headers(i))+40)
      ColWidths += Str$(cWidths(i)) + "|"
   Next i
End Sub

Sub gbGrid_SetCurrentRow
   ListView Get Select hDlgG, %IDC_ListViewG To CurrentRow
   Decr CurrentRow
End Sub

Sub gbGrid_TrueImageSize
   TrueImageSize Xor= 1
End Sub

Sub gbGrid_CaseSensitive
   CaseSensitive Xor= 1
End Sub

Sub gbGrid_EraseSortOrder
   Erase SO()
End Sub

Sub gbGrid_Unselect
   ListView Unselect hDlgG, %IDC_ListViewG, CurrentRow+1
End Sub

Function gbGrid_SelectImageT() As String
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, CFN As String
   Control Get Text hDlgE, %IDE_TextBox To CFN
   title$ = "Open File"
   filter$ = "Images" + $Nul + "*.bmp;*.jpg;*.gif;*.png" + $Nul
   startfolder$ = CFN
   startfile$ = CFN
   defaultext$ = ""
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then Function = LCase$(filevar$)
End Function

Sub gbGrid_NewImage
   Local temp$
   temp$ = gbGrid_SelectImageT
   If Len(temp$) Then
      Control Set Text hDlgE, %IDE_TextBox, temp$
      gbGrid_LoadImage(temp$)
      gbGrid_DisplayImage
   End If
End Sub

Sub gbGrid_GetSortOrder
   Local i As Long
   SortOrder = ""
   If UBound(SO) <> -1 Then
      For i = 0 To UBound(SO)
         If SO(i).dir <> %IconNone Then
            SortOrder += Str$(SO(i).col) + "|" + Str$(So(i).dir) + "|"
         End If
      Next i
   End If
   SortOrder = Trim$(SortOrder,"|")
End Sub

Sub gbGrid_ShowDX
   Local i As Long, temp$
   For i = 1 To UBound(D,2)
      temp$ += Str$(i) + Str$(DX(i)) + $CrLf
   Next i
   ? temp$
End Sub
