'Grid-specific code for DDT ListView by Gary Beene

Type CustomColors
   c(15) As Long
End Type

Enum gbGridEquates Singular
   IDC_ListViewG  = 20000
   IDC_TextBoxIP
   IDC_TextBoxF

   IDX_Right
   IDX_Down
   IDX_Up
   IDX_Left
   IDX_Row
   IDX_Col
   IDX_Ok
   IDX_Cancel

   IDE_ListView
   IDE_TextBox
   IDE_ExitSave
   IDE_ExitNoSave
   IDE_Clear

   IDM_gridCut
   IDM_gridCopy
   IDM_gridDelete
   IDM_gridPaste
   IDM_gridCutT
   IDM_gridCopyT
   IDM_gridDeleteT
   IDM_gridPasteT
   IDM_gridDate
   IDM_gridTime
   IDM_gridNumber
   IDM_gridCurrency
   IDM_gridSum
   IDM_gridFillRight
   IDM_gridFillDown
   IDM_gridFillAll

   IDM_gridEditInplace

   IDM_gridInsertBlockRows
   IDM_gridSelectBlockRows
   IDM_gridDeleteBlockRows

   IDM_gridSelectBlockCols
   IDM_gridInsertBlockCols
   IDM_gridDeleteBlockCols

   IDM_gridSelectContextCol
   IDM_gridDeleteContextCol
   IDM_gridInsertContextCol
   IDM_gridSetHeaderText
   IDM_gridEditDialog

   IDM_gridEdit
   IDM_gridMode
   IDM_gridJump
   IDM_gridVisible
   IDM_gridSep

   IDS_FindThisLabel = 5000
   IDS_ReplaceWithLabel
   IDS_FindThis
   IDS_ReplaceWithThis
   IDS_Replace
   IDS_ReplaceAll
   IDS_SearchNext
   IDS_SearchPrevious
   IDS_CaseSensitive

   EditInPlace = 0
   EditFixed
   EditDialog

   IconAsc = 0
   IconDesc
   IconNone

   XLeft = 1
   XRight
   XUp
   XDown
   XRow
   XCol
End Enum

'Handles - Working variables
Global hDlgG,hTextBoxIP,hTextBoxF,hHeaderG,ghHook    As Dword
Global hContextLV,hContextHdr,hContextTB,hFontG      As Dword
Global hDlgS,hDlgX,hDlgE,hListViewG,hBMP             As Dword

'Working Variables
Global MaxRow, MaxCol,SelInWork,OrigLVProc,OrigTBProc  As Long
Global CurrentRow, CurrentCol, LastSelInWork,XResult   As Long
Global SearchDialogShown                               As Long
Global ContextHeader,SearchDirectionD                  As Long
Global UndoText,CellText,CopyText                      As String
Global SList()                                         As Rect
Global tempD(),tempE()                                 As String

'INI Variables
Global CustomColorList                                     As CustomColors
Global OnColor,OffColor,EnterDown,EditInPlace              As Long
Global EditColor,XTask,EditMode                            As Long
Global FontSize,FontAttr,UseColors,UseEditDialog           As Long
Global FontName,FindThis,ReplaceWithThis,CopySep,ColWidths As WStringZ * %Max_Path

Sub gbGrid_Destroy
   Local i,w As Long
   ColWidths = ""
   For i = 1 To MaxCol
      ListView Get Column hDlgG, %IDC_ListViewG,i To w
      ColWidths += Str$(w) + "|"
   Next i
   SetWindowLong hListViewG, %GWL_WNDPROC, OrigLVProc
   SetWindowLong hTextBoxIP, %GWL_WNDPROC, OrigTBProc
   SetWindowLong hTextBoxF,  %GWL_WNDPROC, OrigTBProc
End Sub

Sub gbGrid_CreateContextMenus
   Local hFill, hRows, hCols, hFormat As Dword
   'Grid context menu
   Menu New PopUp To hFill
   Menu Add String, hFill, "Corner All", %IDM_gridFillAll, %MF_Enabled
   Menu Add String, hFill, "Column Right", %IDM_gridFillRight, %MF_Enabled
   Menu Add String, hFill, "Row Down", %IDM_gridFillDown, %MF_Enabled

   Menu New PopUp To hRows
   Menu Add String, hRows, "Select", %IDM_gridSelectBlockRows, %MF_Enabled
   Menu Add String, hRows, "Insert", %IDM_gridInsertBlockRows, %MF_Enabled
   Menu Add String, hRows, "Delete", %IDM_gridDeleteBlockRows, %MF_Enabled

   Menu New PopUp To hCols
   Menu Add String, hCols, "Select", %IDM_gridSelectBlockCols, %MF_Enabled
   Menu Add String, hCols, "Insert", %IDM_gridInsertBlockCols, %MF_Enabled
   Menu Add String, hCols, "Delete", %IDM_gridDeleteBlockCols, %MF_Enabled

   Menu New PopUp To hFormat
   Menu Add String, hFormat, "Insert Date", %IDM_gridDate, %MF_Enabled
   Menu Add String, hFormat, "Insert Time$", %IDM_gridTime, %MF_Enabled
   Menu Add String, hFormat, "Format As Number", %IDM_gridNumber, %MF_Enabled
   Menu Add String, hFormat, "Format As Currency", %IDM_gridCurrency, %MF_Enabled

   Menu New PopUp To hContextLV
   Menu Add String, hContextLV, "Cut", %IDM_gridCut, %MF_Enabled
   Menu Add String, hContextLV, "Copy", %IDM_gridCopy, %MF_Enabled
   Menu Add String, hContextLV, "Delete", %IDM_gridDelete, %MF_Enabled
   Menu Add String, hContextLV, "Paste", %IDM_gridPaste, %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_gridSep, %MF_Enabled
   Menu Add PopUp,  hContextLV, "Format ...", hFormat, %MF_Enabled
   Menu Add PopUp,  hContextLV, "Fill ...", hFill, %MF_Enabled
   Menu Add PopUp,  hContextLV, "Rows ...", hRows, %MF_Enabled
   Menu Add PopUp,  hContextLV, "Columns ...", hCols, %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_gridSep, %MF_Enabled
   Menu Add String, hContextLV, "Sum Selected Cells", %IDM_gridSum, %MF_Enabled

   'Header context menu
   Menu New PopUp To hContextHdr
   Menu Add String, hContextHdr, "Select Col", %IDM_gridSelectContextCol, %MF_Enabled
   Menu Add String, hContextHdr, "Insert Col", %IDM_gridInsertContextCol, %MF_Enabled
   Menu Add String, hContextHdr, "Delete Col", %IDM_gridDeleteContextCol, %MF_Enabled
   Menu Add String, hContextHdr, "Set Header Text", %IDM_gridSetHeaderText, %MF_Enabled

   'TextBox context menu
   Menu New PopUp To hContextTB
   Menu Add String, hContextTB, "Copy",   %IDM_gridCopyT,  %MF_Enabled
   Menu Add String, hContextTB , "Cut",   %IDM_gridCutT,  %MF_Enabled
   Menu Add String, hContextTB, "Paste",  %IDM_gridPasteT,  %MF_Enabled
   Menu Add String, hContextTB, "Delete", %IDM_gridDeleteT,  %MF_Enabled
End Sub

Sub gbGrid_ItemChanged (Lparam As Long)
   Local LpLvNm As NM_LISTVIEW Ptr
   LpLvNm = LParam
   ListView_SetItemState hListViewG, @LpLvNm.iItem, 0, %LVIS_Focused Or %LVIS_Selected
End Sub

Sub gbGrid_GetDispInfo(lParam As Long)
   Local iRow,iCol As Long, tmp$$
   Local pLVDI As LV_DISPINFOW Ptr
   pLVDI = LParam                'pointer to LVDISPINFO structure for requested subitem
   iRow = @pLVDI.item.iItem+1       'row being asked for D() is 1-based
   iCol = @pLVDI.item.iSubItem+1    'sub item being asked for (columns) D() is 1-based
   tmp$$ = Parse$(D(iCol,DX(iRow)),$Lf,1) + IIf$(ParseCount(D(iCol,DX(iRow)),$Lf)>1," ...","")
   @pLVDI.item.pszText = StrPtr(tmp$$) 'text sent to ListView
End Sub

Sub gbGrid_Edit(InPlaceFlag As Long)
   Local rc As Rect, i,j As Long
   If (EditMode = %EditInPlace) Or InPlaceFlag Then
      'move/resize TextBox over ListView cell
      Control Get Loc hDlgG, %IDC_ListViewG To i,j
      ListView_GetSubItemRect hListViewG, CurrentRow, CurrentCol, %LVIR_Label, rc
      Control Set Loc hDlgG, %IDC_TextBoxIP, i+rc.nLeft, j+rc.nTop
      Control Set Size hDlgG, %IDC_TextBoxIP, rc.nRight-rc.nLeft+4, rc.nBottom-rc.nTop+4
      Control Set Focus hDlgG, %IDC_TextBoxIP
      Control Post hDlgG, %IDC_TextBoxIP, %EM_SetSel, 1, 1    'selectnone
      Control Post hDlgG, %IDC_TextBoxIP, %EM_SetSel, 0, -1   'selectall
      CellText = D(CurrentCol+1, DX(CurrentRow+1))
      gbGrid_PaintBlock 0
   ElseIf EditMode = %EditFixed Then
      Control Set Focus hDlgG, %IDC_TextBoxF
      Control Post hDlgG, %IDC_TextBoxF, %EM_SetSel, 0, -1   'selectall
      CellText = D(CurrentCol+1, DX(CurrentRow+1))
      gbGrid_PaintBlock 0
   Else
      gbGrid_DisplayEditDialog
   End If
End Sub

Sub gbGrid_IDOK
   Select Case GetFocus
      Case hTextBoxIP, hTextBoxF
         'cancel Edit
         Control Set Loc hDlgG, %IDC_TextboxIP, -1000, -1000
         Control Set Focus hDlgG, %IDC_ListViewG
         gbGrid_PaintBlock 0
      Case hListViewG
         If EnterDown Then
            'navigate
            gbGrid_KeyResponse(+1,0)
         Else
            gbGrid_Edit 0
         End If
   End Select
End Sub

Sub gbGrid_CancelEdit
   If GetFocus <> hTextBoxF And GetFocus <> hTextBoxIP Then Exit Sub
   Local rc As Rect
   Control Set Loc hDlgG, %IDC_TextBoxIP, -1000,-1000
   Control Set Text hDlgG, %IDC_TextboxIP, CellText
   Control Set Text hDlgG, %IDC_TextboxF, CellText
   D(CurrentCol+1,DX(CurrentRow+1)) = CellText
   ListView_GetSubItemRect hListViewG, CurrentRow, CurrentCol, %LVIR_Bounds, rc
   InvalidateRect hListViewG, rc, %False
   Control Set Focus hDlgG, %IDC_ListViewG
End Sub

Sub gbGrid_Jump
   Local pt As Point, temp$
   Dialog Get Loc hDlgG To pt.x, pt.y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(gbGrid_InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Enter Col,Row:", Str$(CurrentCol+1) + "," + Str$(CurrentRow+1), pt.x+100,pt.y+100)
   UnhookWindowsHookEx ghHook
   If Len(Trim$(temp$)) Then
      ReDim Preserve SList(1)        'clear all blocks from list
      gbGrid_PaintBlock 0            'erase all blocks
      CurrentCol = Max(0,Min(Val(Parse$(temp$,",",1))-1,MaxCol-1))
      CurrentRow = Max(0,Min(Val(Parse$(temp$,",",2))-1,MaxRow-1))
      SList(1).nLeft = CurrentCol    : SList(1).nTop = CurrentRow
      SList(1).nRight = CurrentCol   : SList(1).nBottom = CurrentRow
      gbGrid_PaintBlock 0
      gbGrid_UpdateTextBoxAndStatusbar
      gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
   End If
End Sub

Sub gbGrid_ENChange
   Local temp$
   FileDirty = 1
   Select Case GetFocus
      Case hTextBoxIP
         Control Get Text hDlgG, %IDC_TextBoxIP To temp$
         Control Set Text hDlgG, %IDC_TextBoxF, temp$
         D(CurrentCol+1,DX(CurrentRow+1)) = temp$
         ListView_RedrawItems hListViewG, CurrentRow, CurrentRow
      Case hTextBoxF
         Control Get Text hDlgG, %IDC_TextBoxF To temp$
         Control Set Text hDlgG, %IDC_TextBoxIP, temp$
         D(CurrentCol+1,DX(CurrentRow+1)) = temp$
         ListView_RedrawItems hListViewG, CurrentRow, CurrentRow
   End Select
End Sub

Sub gbGrid_EnsureVisibleCell(tRow As Long, tCol As Long)
    Local w,h As Long, rc As Rect
    'width of listview
    Control Get Client hDlgG, %IDC_ListViewG To w,h

    'if cell right of client area, scroll back
    ListView_GetSubItemRect hListViewG, tRow, tCol, %LVIR_Bounds, rc
    If rc.nRight > w Then SendMessage(hListViewG, %LVM_Scroll,  rc.nRight-w , ByVal 0)

    'if cell is left of client area, scroll forward
    ListView_GetSubItemRect hListViewG, tRow, tCol, %LVIR_Bounds, rc
    If rc.nLeft < 0 Then SendMessage(hListViewG, %LVM_Scroll,  rc.nLeft, ByVal 0)

    'ensure row is visible
    ListView Visible hDlgG, %IDC_ListViewG, tRow+1
End Sub

Sub gbGrid_UpdateTextBoxAndStatusbar
   Local temp$
   Statusbar Set Text hDlgG, %IDC_StatusBar, 1, 0, "  " + Format$(CurrentCol+1,"#,###,##0") + " : " + Format$(CurrentRow+1,"#,###,##0")
   ListView Get Header hDlgG, %IDC_ListViewG, CurrentCol+1 To temp$
   Statusbar Set Text hDlgG, %IDC_StatusBar, 2, 0, "  " + temp$ + "    " + Format$(CurrentRow+1,"#,###,##0") + " : " + Format$(MaxRow,"#,###,##0")
   Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, gbGrid_STitles
   ListView Get Text hDlgG, %IDC_ListViewG, CurrentRow+1, CurrentCol+1 To temp$
   Control Set Text hDlgG, %IDC_TextBoxIP, temp$
   Control Set Text hDlgG, %IDC_TextBoxF, temp$
End Sub

Sub gbGrid_GoHome
   Local rowResult,colResult As Long
   colresult = -CurrentCol
   If GetAsyncKeyState(%VK_Control) And &H8000 Then rowResult = -CurrentRow
   gbGrid_KeyResponse(rowResult,colresult)
End Sub

Sub gbGrid_SelectAll
   If GetAsyncKeyState(%VK_Control) And &H8000 Then
      ReDim SList(1)
      LastSelInWork = 1
      CurrentRow = 0
      CurrentCol = 0
      SList(1).nLeft  = CurrentCol : SList(1).nTop = CurrentRow
      SList(1).nRight = MaxCol   : SList(1).nBottom = MaxRow
      gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
      gbGrid_UpdateTextBoxAndStatusbar
      gbGrid_PaintBlock 0
   End If
End Sub

Sub gbGrid_GoEnd
   Local rowResult,colResult As Long
   colResult = MaxCol - (CurrentCol+1)
   If GetAsyncKeyState(%VK_Control) And &H8000 Then rowResult = MaxRow - CurrentRow - 1
   gbGrid_KeyResponse(rowResult,colResult)
End Sub

Sub gbGrid_Paste(task$)
   Local temp$,tmp$, x,y,iRows,iCols As Long, tempR As Rect
   FileDirty = 1
   'get text to paste from UndoText or Clipboard, depending on whether Undo or Paste action
   If task$ = "undo" Then
      temp$ = Parse$(UndoText,$CrLf+$CrLf,1)
   Else
      Clipboard Get Text To temp$
      If Len(temp$) = 0 Then Beep : Exit Sub
      If InStr(temp$,CopySep) = 0 Then temp$ += CopySep
      temp$ = Parse$(temp$,$CrLf+$CrLf,1)
   End If

   iRows = ParseCount(temp$,$CrLf)
   tmp$ = Parse$(temp$,$CrLf,1)
   iCols = ParseCount(tmp$,CopySep)-1

   tempR = SList(UBound(SList))
   gbGrid_OrderPoints(tempR)
   For x = 1 To iRows
      If x+tempR.nTop > MaxRow Then Exit For
      tmp$ = Parse$(temp$,$CrLf,x)
      For y = 1 To iCols
         If y+tempR.nLeft > MaxCol Then Exit For
         D(y+tempR.nLeft,DX(x+tempR.nTop)) = Parse$(tmp$,CopySep,y)
      Next y
   Next x

   SList(UBound(SList)).nLeft = tempR.nLeft
   SList(UBound(SList)).nTop = tempR.nTop

   SList(UBound(SList)).nRight = Min(MaxCol,tempR.nLeft + iCols - 1)
   SList(UBound(SList)).nBottom = Min(MaxRow,tempR.nTop + iRows - 1)

   gbGrid_UpdateTextBoxAndStatusbar
   gbGrid_PaintBlock(0)
End Sub

Sub gbGrid_CutCopyDelete(task$)
   Local i,x,y As Long, tempR As Rect
   CopyText = ""
   If task$ <> "copy" Then
      FileDirty = 1
      Control Set Text hDlgG,%IDC_TextBoxF, ""
      Control Set Text hDlgG,%IDC_TextBoxIP, ""
   End If
   For i = UBound(SList) To 1 Step -1
      tempR = SList(i)
      gbGrid_OrderPoints tempR
      For x = tempR.nTop To tempR.nBottom
         For y = tempR.nLeft To tempR.nRight
            CopyText += D(y+1,DX(x+1)) + CopySep
            If task$ <> "copy" Then D(y+1,DX(x+1)) = ""
         Next y
         CopyText += $CrLf
      Next x
      CopyText += $CrLf
   Next i
   If task$ <> "delete" Then Clipboard Reset : Clipboard Set Text CopyText
   If task$ <> "copy" Then UndoText = Parse$(CopyText,$CrLf+$CrLf,1) : gbGrid_PaintBlock(0)
End Sub

Sub gbGrid_GetUndoText
   Local i,x,y As Long, tempR As Rect
   UndoText = ""
   i = UBound(SList)
   tempR = SList(i)
   gbGrid_OrderPoints tempR
   For x = tempR.nTop To tempR.nBottom
      For y = tempR.nLeft To tempR.nRight
         UndoText += D(y+1,DX(x+1)) + CopySep
      Next y
      UndoText += $CrLf
   Next x
   UndoText += $CrLf
End Sub

Function gbGrid_CellInList(iRow As Long, iCol As Long) As Long
   Local i As Long, tempR As Rect, pt As Point
   pt.x = iCol : pt.y = iRow
   For i = 1 To UBound(SList)
      'reorder rect corners to work with pt in rect
      tempR.nLeft = Min&(SList(i).nLeft,SList(i).nRight)
      tempR.nRight = Max&(SList(i).nLeft,SList(i).nRight)+1
      tempR.nTop = Min&(SList(i).nTop,SList(i).nBottom)
      tempR.nBottom = Max&(SList(i).nTop,SList(i).nBottom)+1
      If PtInRect(tempR,pt) Then
         Function = 1 : Exit Function
      End If
   Next i
End Function

Function gbGrid_CustomDraw(LParam As Long) As Long
   Local lplvcd As NMLVCUSTOMDRAW Ptr, rc, rch As Rect, hDC As Dword
   lpLvCd = LParam
   Select Case @lplvcd.nmcd.dwDrawStage
      Case %CDDS_PREPAINT, %CDDS_ITEMPREPAINT
         Function = %CDRF_NOTIFYPOSTPAINT Or %CDRF_NOTIFYSUBITEMDRAW
      Case %CDDS_ITEMPREPAINT Or %CDDS_SUBITEM
         If UseColors Then
            If gbGrid_CellInList(@lplvcd.nmcd.dwItemSpec,@lpLvCd.iSubItem) Then
               Select Case GetFocus
                  Case hListViewG : @lpLvCd.clrTextBk = OnColor
                  Case hTextBoxIP : @lpLvCd.clrTextBk = EditColor
                  Case Else       : @lpLvCd.clrTextBk = OffColor
               End Select
            Else
               @lpLvCd.clrTextBk = %White
            End If
            Function = %CDRF_NEWFONT
         End If
      Case %CDDS_POSTPAINT
          Header_GetItemRect hHeaderG, CurrentCol, rch
          ListView_GetSubItemRect hListViewG, CurrentRow, CurrentCol, %LVIR_LABEL, rc
          If IntersectRect (rch, rc, rch) = 0 Then   'don't draw on header
             hDC = GetDC(hListViewG)
             FrameRect hDC, rc, GetStockObject(%BLACK_BRUSH)
             ReleaseDC hListViewG, hDC
          End If
          Function = %CDRF_NEWFONT
   End Select
End Function

Sub gbGrid_PaintBlock(iBlock As Long)  'iBlock=0 means invalidate entire client area
   Local rr,rb As Rect,w,h As Long
   If iBlock Then
      ListView_GetSubItemRect hListViewG, SList(iBlock).nTop, SList(iBlock).nLeft, %LVIR_Label, rb
      rr.nLeft  = rb.nLeft
      rr.nTop   = rb.nTop
      ListView_GetSubItemRect hListViewG, SList(iBlock).nBottom, SList(iBlock).nRight, %LVIR_Label, rb
      rr.nRight  = rb.nRight
      rr.nBottom = rb.nBottom
      InvalidateRect hListViewG, rr, %False
   Else
      Control Get Client hDlgG, %IDC_ListViewG To w,h
      rr.nLeft = 0  : rr.nTop = 0
      rr.nRight = w : rr.nBottom = h
      InvalidateRect hListViewG, rr, %False
   End If
End Sub

Sub gbGrid_KeyResponse(RowDelta As Long, ColDelta As Long)
   If (GetAsyncKeyState(%VK_Shift) And &H8000) Then    'shift is down
      'extend selection
      SList(LastSelInWork).nRight  = Max(0,Min(SList(LastSelInWork).nRight+ColDelta,MaxCol-1))
      SList(LastSelInWork).nBottom = Max(0,Min(SList(LastSelInWork).nBottom+RowDelta,MaxRow-1))
      gbGrid_EnsureVisibleCell  SList(LastSelInWork).nBottom, SList(LastSelInWork).nRight
   Else
      'single cell selection
      ReDim SList(1)
      LastSelInWork = 1
      gbGrid_PaintBlock 0
      CurrentRow = Max(0,Min(CurrentRow+RowDelta,MaxRow-1))
      CurrentCol = Max(0,Min(CurrentCol+ColDelta,MaxCol-1))
      SList(1).nLeft  = CurrentCol : SList(1).nTop = CurrentRow
      SList(1).nRight = CurrentCol : SList(1).nBottom = CurrentRow
      gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
   End If
   gbGrid_UpdateTextBoxAndStatusbar
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_OrderPoints(S As Rect)
   Local tempR As Rect
   tempR.nLeft = Min&(S.nLeft,S.nRight)
   tempR.nRight = Max&(S.nLeft,S.nRight)
   tempR.nTop = Min&(S.nTop,S.nBottom)
   tempR.nBottom = Max&(S.nTop,S.nBottom)
   S = tempR
End Sub

Sub gbGrid_SelectContextCol
   SList(1) = SList(UBound(SList))
   ReDim Preserve SList(1)
   LastSelInWork = 1
   SList(1).nLeft = ContextHeader
   SList(1).nTop = 0
   SList(1).nRight = ContextHeader
   SList(1).nBottom = MaxRow-1
   CurrentCol = ContextHeader
   CurrentRow = 0
   gbGrid_PaintBlock 0
   gbGrid_UpdateTextBoxAndStatusbar
   gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
End Sub

Sub gbGrid_SelectRC
   Local i As Long, tempR As Rect
   If GetAsyncKeyState(%VK_Control) And &H8000 Then
      i = UBound(SList)
      tempR = SList(i)
      gbGrid_OrderPoints tempR
      ReDim Preserve SList(i)
      SList(i).nLeft = tempR.nLeft
      SList(i).nTop = 0
      SList(i).nRight = tempR.nRight
      SList(i).nBottom = MaxRow-1
      gbGrid_PaintBlock 0
      gbGrid_UpdateTextBoxAndStatusbar
      gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
   ElseIf GetAsyncKeyState(%VK_Shift) And &H8000 Then
      i = UBound(SList)
      tempR = SList(i)
      gbGrid_OrderPoints tempR
      ReDim Preserve SList(i)
      SList(i).nLeft = 0
      SList(i).nTop = tempR.nTop
      SList(i).nRight = MaxCol-1
      SList(i).nBottom = tempR.nBottom
      gbGrid_PaintBlock 0
      gbGrid_UpdateTextBoxAndStatusbar
      gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
   End If
End Sub

Sub gbGrid_Modify(task$)
   Local i,x,y As Long, tempR As Rect, temp$
   FileDirty = 1
   For i = UBound(SList) To 1 Step -1
      tempR = SList(i)
      gbGrid_OrderPoints tempR
      For x = tempR.nTop To tempR.nBottom
         For y = tempR.nLeft To tempR.nRight
            Select Case task$
               Case "date"
                 D(y+1,DX(x+1)) = Date$
               Case "time"
                 D(y+1,DX(x+1)) = Time$
               Case "number"
                  temp$ = D(y+1,DX(x+1))
                  Replace "$" With "" In temp$
                  Replace "," With "" In temp$
                  D(y+1,DX(x+1)) = Format$(Val(temp$),"###,###,###")
               Case "currency"
                  temp$ = D(y+1,DX(x+1))
                  Replace "$" With "" In temp$
                  Replace "," With "" In temp$
                  D(y+1,DX(x+1)) = Format$(Val(temp$),"$###,###,##0.00")
            End Select

         Next y
      Next x
   Next i
   gbGrid_PaintBlock(0)
End Sub

Function gbGrid_SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlgG, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub gbGrid_onColor
   OnColor = gbGrid_SelectColor(OnColor)
End Sub

Sub gbGrid_offColor
   OffColor = gbGrid_SelectColor(OffColor)
End Sub

Sub gbGrid_EditColor
   EditColor = gbGrid_SelectColor(EditColor)
End Sub

Sub gbGrid_CreateStatusBar
   Control Add Statusbar, hdlg, %IDC_StatusBar, "", 0,0,0,0
   Statusbar Set Parts hDlg, %IDC_StatusBar, 150,250,99999
End Sub

Sub gbGrid_CreateEditBoxes
   'fixed editor
   Control Add TextBox, hDlgG, %IDC_TextBoxF, "", 10,500,50,20, %WS_TabStop Or %WS_Border Or %ES_AutoHScroll, %WS_Ex_ClientEdge
   Control Set Color hDlgG, %IDC_TextBoxF, %Black ,EditColor
   Control Handle hDlgG, %IDC_TextBoxF To hTextBoxF
   OrigTBProc = SetWindowLong(hTextBoxF, %GWL_WndProc, CodePtr(gbGrid_NewTBProc))  'subclass

   'Inplace textbox
   Control Add TextBox, hDlgG, %IDC_TextBoxIP, "", -1000,-1000,500,20,%WS_TabStop Or %WS_Border Or %ES_AutoHScroll, %WS_Ex_ClientEdge
   Control Handle hDlgG, %IDC_TextBoxIP To hTextBoxIP
   OrigTBProc = SetWindowLong(hTextBoxIP, %GWL_WndProc, CodePtr(gbGrid_NewTBProc))  'subclass
End Sub

Function gbGrid_InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr, iStyle As Long
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam : cst = @cw.lpcs                ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then
         Select Case @cst.hMenu
            Case %IdOk   :   @cst.x=20:@cst.y=45:@cst.cx=60
            Case %IdCancel : @cst.x=110:@cst.y=45:@cst.cx=60
         End Select
      End If
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400  'prompt moved out of the way
      If UCase$(szTemp) = "EDIT"   Then
         @cst.x = 10   : @cst.y = 10 : @cst.cx = 175 : @cst.cy = 30
         iStyle = GetWindowLong(wParam,%GWL_Style)
         SetWindowLong wparam, %GWL_Style, iStyle 'Or %ES_Password
      End If
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = 100  'dialog
   End If
End Function

Sub gbGrid_CreateListView
   Local hImageList As Dword, w,h As Long
   Dialog Get Client hDlgG To w,h
   Control Kill hDlgG, %IDC_ListViewG
'   Control Add ListView, hDlgG, %IDC_ListViewG,"", 10,60,w-20,h-70,  %WS_TabStop Or %WS_Visible Or %LVS_Report Or %LVS_OwnerData Or %LVS_SingleSel Or %LVS_ShowSelAlways, %WS_Ex_ClientEdge
   Control Add ListView, hDlgG, %IDC_ListViewG,"", 10,60,0,0,  %WS_TabStop Or %WS_Visible Or %LVS_Report Or %LVS_OwnerData Or %LVS_SingleSel Or %LVS_ShowSelAlways, %WS_Ex_ClientEdge
   Control Handle hDlgG, %IDC_ListViewG To hListViewG
   ListView Set StyleXX hDlgG, %IDC_ListViewG, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
   OrigLVProc = SetWindowLong(hListViewG, %GWL_WndProc, CodePtr(gbGrid_LVProc))  'subclass LV
   hHeaderG = ListView_GetHeader(hListViewG)
   'create imagelist
   ImageList New Icon 16,16,24,2 To hImageList
   ImageList Add Icon hImageList, "xup"        'ascending
   ImageList Add Icon hImageList, "xdown"      'descending
   'assign imagelist to header
   hHeaderG = ListView_GetHeader(hListViewG)
   Header_SetImageList hHeaderG, hImagelist
End Sub

Sub gbGrid_CreateFakeData
   Local i,j As Long
   MaxRow = 1000  : MaxCol = 9
   ReDim D(1 To MaxCol,1 To MaxRow)
   ReDim DX(MaxRow)
   ReDim Headers(1 To MaxCol)
   Array Assign Headers() = "Random", "Words", "From", "The", "Constitution", "of", "the", "United", "States"
   'read in words from the constitution
   Open "files\wordlist.txt" For Input As #1
   FileScan #1, Records To i
   Dim Words(i-1) As String
   Line Input #1, Words()
   Close #1
   Randomize Timer
   For i = 1 To MaxCol
      For j = 1  To MaxRow
         D(i,j) = Words(Rnd(0,UBound(Words)))
      Next j
   Next i
End Sub

Function gbGrid_NewTBProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_SetFocus
         If hWnd = hTextBoxF Then
            Control Set Color hDlgG, %IDC_TextBoxF, %Black, EditColor
            Control Get Text hDlgG, %IDC_TextBoxF To CellText
         End If

      Case %WM_KillFocus : If hWnd = hTextBoxF Then Control Set Color hDlgG, %IDC_TextBoxF, %Black, %White
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTB, %TPM_LeftAlign, x, y, 0, hDlgG, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OrigTBProc, hWnd, Msg, wParam, lParam)
End Function

Function gbGrid_Font() As Long
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(gbGrid_FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlgG, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      gbGrid_CreateFont
   End If
End Function

Function gbGrid_FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
   End If
End Function

Sub gbGrid_Undo
   If Len(UndoText) Then
      gbGrid_Paste "undo"
      UndoText = ""
      FileDirty = 1
   Else
      Beep
   End If
End Sub

Function gbGrid_LVProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local i,x,y As Long, LVHT As LVHITTESTINFO, pt As Point, rc As Rect
   Select Case Msg
      Case %WM_LButtonDown
         LVHT.pt.x = Lo(Word,LPARAM) : LVHT.pt.y = Hi(Word,LPARAM)
         gbGrid_CancelEdit
         If ListView_SubItemHitTest(hListViewG, LVHT)>-1 Then
            If (GetAsyncKeyState(%VK_Control) And &H8000) Then                  'control is down
               'new block
               i = UBound(SList)+1
               ReDim Preserve SList(i)
               SList(i).nLeft = LVHT.iSubItem      : SList(i).nTop = LVHT.iItem
               SList(i).nRight = LVHT.iSubItem     : SList(i).nBottom = LVHT.iItem
               CurrentCol = SList(i).nLeft         : CurrentRow = SList(i).nTop
            ElseIf (GetAsyncKeyState(%VK_Shift) And &H8000) Then                'shift is down
               'extend current block
               SList(LastSelInWork).nRight = LVHT.iSubItem : SList(LastSelInWork).nBottom = LVHT.iItem
            Else                                                                'neither control nor shift are down
               ReDim Preserve SList(1)        'clear all blocks from list
               gbGrid_PaintBlock 0            'erase all blocks
               SList(1).nLeft = LVHT.iSubItem      : SList(1).nTop = LVHT.iItem
               SList(1).nRight = LVHT.iSubItem     : SList(1).nBottom = LVHT.iItem
               CurrentCol = SList(1).nLeft         : CurrentRow = SList(1).nTop
            End If
            gbGrid_PaintBlock 0
            SelInWork = UBound(SList)
         End If
         gbGrid_UpdateTextBoxAndStatusbar
         Function = 1 : Exit Function
      Case %WM_MouseMove
         If SelInWork Then
            LVHT.pt.x = Lo(Word,LPARAM) : LVHT.pt.y = Hi(Word,LPARAM)
            If ListView_SubItemHitTest(hListViewG, LVHT) > -1 Then
               If (LVHT.iSubItem <> SList(SelInWork).nRight) Or (LVHT.iItem <> SList(SelInWork).nBottom) Then
                  SList(SelInWork).nRight = LVHT.iSubItem
                  SList(SelInWork).nBottom = LVHT.iItem
                  gbGrid_PaintBlock 0
               End If
            End If
            gbGrid_UpdateTextBoxAndStatusbar
         End If
      Case %WM_LButtonUp
         LastSelInWork = SelInWork
         SelInWork = 0
      Case %WM_ContextMenu
         GetWindowRect hHeaderG, rc
         pt.x = Lo(Integer,LParam) : pt.y = Hi(Integer, LParam)  'WM_ContextMenu returns xy coordinates of mouse
         ScreenToClient hListViewG, pt
         If Hi(Integer, LParam) < rc.nBottom Then  'is over header
            ContextHeader = gbGrid_GetContextHeader(pt)
            x = Lo(Integer,LParam) : y = Hi(Integer, LParam)    'WM_ContextMenu returns xy coordinates of mouse
            TrackPopupMenu hContextHdr, %TPM_LeftAlign, x, y, 0, hDlgG, ByVal 0   'put context menu where mouse is
            Function = 0 : Exit Function
         Else               'is not over header
            x = Lo(Integer,LParam) : y = Hi(Integer, LParam)    'WM_ContextMenu returns xy coordinates of mouse
            TrackPopupMenu hContextLV, %TPM_LeftAlign, x, y, 0, hDlgG, ByVal 0   'put context menu where mouse is
            Function = 0 : Exit Function
         End If

      Case %WM_KeyDown
         gbGrid_CancelEdit
         Select Case wParam
            Case %VK_TAB    : gbGrid_KeyResponse(0,+1) : Exit Function
            Case %VK_A      : gbGrid_SelectAll
            Case %VK_C      : gbGrid_CutCopyDelete "copy"
            Case %VK_X      : gbGrid_CutCopyDelete "cut"
            Case %VK_Delete : gbGrid_GetUndoText : gbGrid_CutCopyDelete "delete" : SetMenusAndToolbar
            Case %VK_V      : gbGrid_Paste "clipboard"
            Case %VK_Return : If EnterDown Then gbGrid_KeyResponse(+1,0) Else gbGrid_Edit(0)
            Case %VK_Up     : gbGrid_KeyResponse(-1,0)
            Case %VK_Down   : gbGrid_KeyResponse(+1,0)
            Case %VK_Left   : gbGrid_KeyResponse(0,-1) : Exit Function
            Case %VK_Right  : gbGrid_KeyResponse(0,+1) : Exit Function
            Case %VK_Pgup   : gbGrid_KeyResponse(-ListView_GetCountPerPage(hListViewG)+1,0)
            Case %VK_PgDn   : gbGrid_KeyResponse(ListView_GetCountPerPage(hListViewG)-1,0)
            Case %VK_Home   : gbGrid_GoHome
            Case %VK_End    : gbGrid_GoEnd
            Case %VK_Space  : gbGrid_SelectRC
        End Select
   End Select
   Function = CallWindowProc(OrigLVProc, hWnd, Msg, wParam, lParam)
End Function

Sub gbGrid_SetHeaderText
   Local pHdi As HDItem, tempZ As WStringZ * 30, x,y,iCol As Long
   FileDirty = 1
   'get iCol
   iCol = ContextHeader+1
   'ask user for new header title
   Dialog Get Loc hDlgG To x,y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(gbGrid_InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   tempZ = InputBox$("", "Enter Header Title:", Headers(iCol), x+100, y+100)
   UnhookWindowsHookEx ghHook
   If Len(tempZ) Then
      pHdi.mask    = %HDI_Text
      pHdi.pszText = VarPtr(tempZ)
      Header_SetItem hHeaderG, iCol-1, pHdi
   End If
End Sub

Sub gbGrid_SetHeaderIconOnRight(ByVal iCol As Integer, iImg As Long)
   Local hdi As HD_ITEM
   hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
   hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right
   hdi.iImage = iImg
   Header_SetItem(hHeaderG, iCol-1, hdi)
End Sub

Sub gbGrid_ClearIconOnRight(iCol As Integer)
   Local hdi As HD_ITEM
   hdi.mask = %HDI_FORMAT
   hdi.fmt = %HDF_String
   Header_SetItem(hHeaderG, iCol-1, hdi)
End Sub

Sub gbGrid_ClearAllSortIcons
   Local i As Integer
   For i = 0 To Header_GetItemCount(hHeaderG) - 1
      gbGrid_ClearIconOnRight i+1
   Next
End Sub

Function gbGrid_STitles() As String
   Local i As Long, temp$, tmp$
   If UBound(SO) = -1 Then Exit Function
   For i = 0 To UBound(SO)
      ListView Get Header hDlgG, %IDC_ListViewG, SO(i).col To tmp$
      temp$ += IIf$(SO(i).dir=0," +"," -") + tmp$   'SO().dir  0=asc  1=desc
   Next i
   Function = temp$
End Function

Function gbGrid_CurrentSortDirection(iCol As Long) As Long   'get sort direction SO() element containing iCol
   Local i As Long
   Function = %IconNone
   If UBound(SO) = -1 Then Exit Function
   For i = 0 To UBound(SO)
      If SO(i).col = iCol Then Function = SO(i).dir : Exit Function
   Next i
End Function

Function gbGrid_SOLocation(iCol As Long) As Long  'get SO() element containing iCol
   Local i As Long
   Function = -1
   If UBound(SO) =  -1 Then Exit Function
   For i = 0 To UBound(SO)
      If SO(i).col = iCol Then Function = i : Exit Function
   Next i
End Function

Sub gbGrid_ColumnClick(iCol As Long)
   Local i As Long
   gbGrid_RestoreOriginalOrder
   If (GetAsyncKeyState(%VK_SHIFT) And &H8000) Then
      i = gbGrid_SOLocation(iCol)
      If i = -1 Then
         'iCol is not in SO so add iCol to SO
         i = UBound(SO) + 1
         ReDim Preserve SO(i)
         SO(i).col = iCol
         SO(i).dir = %IconAsc   'when added, always set to %IconASC
         gbGrid_SetHeaderIconOnRight SO(i).col, SO(i).dir  'col,img
         If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()
      Else
         Incr SO(i).dir
         If SO(i).dir > %IconNone Then SO(i).dir = %IconAsc
         gbGrid_SetHeaderIconOnRight SO(i).col, SO(i).dir  'col,img
         If SO(i).dir = %IconNone Then  'remove from array
            If UBound(SO) = 0 Then
               Erase SO
            Else
               Array Delete SO(i)
               ReDim Preserve SO(UBound(SO)-1)
            End If
         End If
         If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()
      End If
   Else
      gbGrid_ClearAllSortIcons
      i = gbGrid_CurrentSortDirection(iCol)
      Select Case i
         Case %IconAsc, %IconNone
            ReDim SO(0)       'going to descending or ascending
            SO(0).col = iCol
            SO(0).dir = IIf(i=%IconAsc,%IconDesc,%IconAsc)
            gbGrid_SetHeaderIconOnRight SO(0).col, SO(0).dir  'col,img
            If (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()
         Case %IconDesc
            Erase SO()       'going to no icons
      End Select
   End If
   Control ReDraw hDlgG, %IDC_ListViewG
End Sub


Sub gbSearch_DisplaySearchDialog
   Dialog Font "Tahoma",10,0
   Dialog New Pixels, hDlgG, "Find & Replace", 100, 100, 340, 100, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hDlgS
   Dialog Set Icon hDlgS, "xsearch"

   Control Add Label, hDlgS, %IDS_FindThisLabel, "Find This:", 5, 10, 80, 20
   Control Add Label, hDlgS, %IDS_FindThisLabel, "Replace With:", 5, 40, 80, 20

   'If Len(Sci_GetSelText(hSciTarget)) Then SearchTermD = Sci_GetSelText(hSciTarget)
   Control Add TextBox, hDlgS, %IDS_FindThis, FindThis, 90, 10, 150, 20, %WS_TabStop Or %WS_Border Or %ES_AutoHScroll, %WS_Ex_ClientEdge
   Control Add TextBox, hDlgS, %IDS_ReplaceWithThis, ReplaceWithThis, 90, 40, 150, 20, %WS_TabStop Or %WS_Border Or %ES_AutoHScroll, %WS_Ex_ClientEdge

   Control Add Button, hDlgS, %IDS_SearchNext, "Find Next", 250, 10, 80, 25
   Control Add Button, hDlgS, %IDS_SearchPrevious, "Find Prev", 250, 40, 80, 25
   Control Add Button, hDlgS, %IDS_Replace, "Replace", 250, 70, 80, 25

   Control Add CheckBox, hDlgS, %IDS_CaseSensitive, "Case Sensitive", 10, 70, 100, 20
   Control Set Check hDlgS, %IDS_CaseSensitive, CaseSensitive

   Control Add Button, hDlgS, %IdOk, "Ok", 200, 230, 20, 20
   Control Add Button, hDlgS, %IdCancel, "Cancel", 230, 230, 20, 20
   Control Show State hDlgS, %IdOk, %SW_Hide
   Control Show State hDlgS, %IdCancel, %SW_Hide

   SearchDialogShown = 1
   Dialog Show Modeless hDlgS Call gbSearch_DlgProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop Until SearchDialogShown = 0

End Sub

CallBack Function gbSearch_DlgProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog : SearchDirectionD = 1
      Case %IdCancel      : SearchDialogShown = 0 : Dialog End hDlgS
      Case %WM_Destroy    : SearchDialogShown = 0 : Control Set Focus hDlgG, %IDC_ListViewG
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDS_FindThis   : If Cb.CtlMsg = %EN_Change Then Control Get Text hDlgS, %IDS_FindThis To FindThis
            Case %IDS_ReplaceWithThis : If Cb.CtlMsg = %EN_Change Then Control Get Text hDlgS, %IDS_ReplaceWithThis To ReplaceWithThis
            Case %IDS_CaseSensitive   : Control Get Check hDlgS, %IDS_CaseSensitive To CaseSensitive
            Case %IDS_Replace
               Replace FindThis With ReplaceWithThis In D(CurrentCol+1,CurrentRow+1)
               gbGrid_PaintBlock 0  : gbSearch_FindText
            Case %IdCancel            : SearchDialogShown = 0 : Dialog End hDlgS
            Case %IdOk                : gbSearch_FindText
            Case %IDS_SearchNext      : SearchDirectionD = 1  : gbSearch_FindText         'search forward
            Case %IDS_SearchPrevious  : SearchDirectionD = 0  : gbSearch_FindText         'search backward
         End Select
   End Select
End Function

Function gbSearch_FindText() As Long
   Local i,x,y,iResult As Long, sTerm$, mTerm$
   sTerm$ = IIf$(CaseSensitive,FindThis,LCase$(FindThis))
   If SearchDirectionD Then
      For i = CurrentRow * MaxCol + CurrentCol + 1 To (MaxRow-1) * (MaxCol-1)
         x = i \ MaxCol + 1
         y = i Mod MaxCol + 1
         mTerm$ = IIf$(CaseSensitive,D(y,x),LCase$(D(y,x)))
         iResult = InStr(mTerm$,sTerm$)
         If iResult Then Exit For
      Next i
  Else
      For i = CurrentRow * MaxCol + CurrentCol - 1 To 0 Step -1
         x = i \ MaxCol + 1
         y = i Mod MaxCol + 1
         mTerm$ = IIf$(CaseSensitive,D(y,x),LCase$(D(y,x)))
         iResult = InStr(mTerm$,sTerm$)
         If iResult Then Exit For
      Next i
  End If
  If iResult Then
     ReDim SList(1)
     LastSelInWork = 1
     SList(1).nLeft = y-1  : SList(1).nTop = x-1
     SList(1).nRight = y-1 : SList(1).nBottom = x-1
     CurrentCol = y-1      : CurrentRow = x-1
     gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
     gbGrid_PaintBlock(0)
     gbGrid_UpdateTextBoxAndStatusbar
  Else
     If SearchDirectionD = 1 Then gbGrid_MsgBox "Match not found between current position and end of document!", %MB_Ok Or %MB_TaskModal Or %MB_IconExclamation, "Find Text"
     If SearchDirectionD = 0 Then gbGrid_MsgBox "Match not found between current position and beginning of document!", %MB_Ok Or %MB_TaskModal Or %MB_IconExclamation, "Find Text"
  End If
End Function

Sub gbGrid_ResetSList
   ReDim SList(1)
   LastSelInWork = 1
   SList(1).nLeft = 0  : SList(1).nTop = 0
   SList(1).nRight = 0 : SList(1).nBottom = 0
   CurrentCol = 0      : CurrentRow = 0
End Sub

Sub gbGrid_DeleteCol(iCol As Long)             'iCol is 1-based
   Local i,x,y,SortFlag As Long
   If UBound(D,1) = 1 Then Beep : Exit Sub     'cannot delete last column
   FileDirty = 1

   'create tempD() that does not have the column
   ReDim tempD(1 To UBound(D,1)-1,1 To UBound(D,2))
   For y = 1 To UBound(D,1)          'col
      If y = iCol Then Iterate For
      For x = 1 To UBound(D,2)       'row
         If y < iCol Then tempD(y,x) = D(y,x)
         If y > iCol Then tempD(y-1,x) = D(y,x)
      Next x
   Next y

   'listview
   Decr MaxCol
   ListView Delete Column hDlgG, %IDC_ListViewG, iCol

   'resize D, copy tempD to D
   ListView_SetItemCountEx(hListViewG, 0, %LVSICF_noInvalidateAll) 'max rows
   ReDim D(1 To UBound(tempD,1),1 To UBound(tempD,2))
   For y = 1 To UBound(tempD,1)
      For x = 1 To UBound(tempD,2)
         D(y,x) = tempD(y,x)
      Next x
   Next y
   ListView_SetItemCountEx(hListViewG, UBound(D,2), %LVSICF_noInvalidateAll) 'max rows

   'sort order
   For i = 0 To UBound(SO)
      If SO(i).col = iCol Then
         SortFlag = 1
         gbGrid_ClearIconOnRight((iCol))
         If UBound(SO)>0 Then
            Array Delete SO(i)
            ReDim Preserve SO(UBound(SO)-1)
         Else
            Erase SO()
         End If
         Exit For
      End If
   Next i
   jpGetColTypes D(), UBound(D,1), UBound(D,2)
   If SortFlag And (UBound(SO)>-1) Then jpSortCols D(), UBound(D,1), UBound(D,2), DX(), SO()

   'selections
   ReDim SList(1)
   LastSelInWork = 1
   CurrentCol = Min(iCol-1,MaxCol-1)
   CurrentRow = 0
   SList(1).nTop = 0
   SList(1).nBottom = 0
   SList(1).nLeft = CurrentCol
   SList(1).nRight = CurrentCol
   gbGrid_UpdateTextBoxAndStatusbar
   Control Set Focus hDlgG, %IDC_ListViewG
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_DeleteBlockCols
   Local tempR As Rect, i As Long
   tempR = SList(UBound(SList))
   gbGrid_OrderPoints(tempR)
   If tempR.nRight - tempR.nLeft + 1 = MaxCol Then Beep : Exit Sub   'cannot delete all columns
   ContextHeader = tempR.Left
   For i = tempR.nLeft To tempR.nRight
      gbGrid_DeleteCol(tempR.nLeft+1)
   Next i
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_InsertBlockCols
   Local tempR As Rect, i As Long
   tempR = SList(UBound(SList))
   gbGrid_OrderPoints(tempR)
   ContextHeader = tempR.Left
   For i = tempR.nLeft To tempR.nRight
      gbGrid_InsertCol(tempR.nLeft+1)
   Next i
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_InsertCol(iCol As Long)
   Local i,x,y As Long
   FileDirty = 1

   'create tempD() that does not have the column
   ReDim tempD(1 To UBound(D,1)+1,1 To UBound(D,2))
   For y = 1 To UBound(D,1)
      For x = 1 To UBound(D,2)
         If y < iCol Then tempD(y,x) = D(y,x)
         If y >= iCol Then tempD(y+1,x) = D(y,x)
      Next x
   Next y

   'listview
   Incr MaxCol
   ListView Insert Column hDlgG, %IDC_ListViewG, iCol, "New", 100, 0

   'resize D, copy tempD to D
   ListView_SetItemCountEx(hListViewG, 0, %LVSICF_noInvalidateAll) 'no rows
   ReDim D(1 To UBound(tempD,1),1 To UBound(tempD,2))
   For y = 1 To UBound(tempD,1)
      For x = 1 To UBound(tempD,2)
         D(y,x) = tempD(y,x)
      Next
   Next y
   ListView_SetItemCountEx(hListViewG, UBound(D,2), %LVSICF_noInvalidateAll) 'max rows

   'sort order
   For i = 0 To UBound(SO)
      If SO(i).col >= iCol Then Incr SO(i).col
   Next i
   jpGetColTypes D(), UBound(D,1), UBound(D,2)

   'selections
   ReDim SList(1)
   LastSelInWork = 1
   CurrentCol = iCol-1
   SList(1).nTop = CurrentRow
   SList(1).nBottom = CurrentRow
   SList(1).nLeft = CurrentCol
   SList(1).nRight = CurrentCol
   gbGrid_UpdateTextBoxAndStatusbar
   gbGrid_PaintBlock 0
   Control Set Focus hDlgG, %IDC_ListViewG
End Sub

Function gbGrid_GetContextHeader(pt As Point) As Long
   Local hti As HD_HitTestInfo
   hti.pt = pt
   SendMessage hHeaderG, %hdm_HitTest, 0, VarPtr(hti)     'see what column we are over
   Function = hti.iItem
End Function


Sub gbGrid_SelectBlockCols
   SList(1) = SList(UBound(SList))
   ReDim Preserve SList(1)
   LastSelInWork = 1
   SList(1).nTop = 0
   SList(1).nBottom = MaxRow-1
   gbGrid_PaintBlock 0
   gbGrid_UpdateTextBoxAndStatusbar
   gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
End Sub

Sub gbGrid_SelectBlockRows
   SList(1) = SList(UBound(SList))
   ReDim Preserve SList(1)
   LastSelInWork = 1
   SList(1).nLeft = 0
   SList(1).nRight = MaxCol-1
   gbGrid_PaintBlock 0
   gbGrid_UpdateTextBoxAndStatusbar
   gbGrid_EnsureVisibleCell CurrentRow, CurrentCol
End Sub

Sub gbGrid_InsertBlockRows
   Local i,x,y,RowCount As Long, tempR As Rect
   FileDirty = 1
   'initialize and exit if required
   tempR = SList(UBound(SList))
   gbGrid_OrderPoints tempR
   RowCount = tempR.nBottom - tempR.nTop + 1

   'ReDim D() and DX() and MaxRow
   ReDim Preserve D(1 To UBound(D,1),1 To UBound(D,2)+RowCount)
   MaxRow = UBound(D,2)
   ReDim Preserve DX(UBound(D,2))

   'move stuff up one
   For y = 1 To UBound(D,1)
      For x = UBound(D,2) To tempR.nBottom+2 Step -1
         D(y,x) = D(y,x-RowCount)
      Next y
      For x = tempR.nTop+1 To tempR.nBottom+1
         D(y,x) = ""
      Next y
   Next x

   'fix DX()
   For i = UBound(DX) To tempR.nBottom+2 Step -1
      DX(i) = DX(i-RowCount)
      If DX(i) >= tempR.nTop+1 Then DX(i) += RowCount
   Next i
   For i = tempR.nTop +1 To tempR.nBottom + 1
      DX(i) = i
   Next i

   'select currentrow/currentcol
   SList(UBound(SList)).nTop = CurrentRow
   SList(UBound(SList)).nBottom = CurrentRow
   SList(UBound(SList)).nLeft = CurrentCol
   SList(UBound(SList)).nRight = CurrentCol
   Control Set Focus hDlgG, %IDC_ListViewG

   ListView_SetItemCountEx(hListViewG, UBound(D,2), %LVSICF_noInvalidateAll) 'max rows
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_DeleteBlockRows
   Local i,x,y,RowCount As Long, tempR As Rect
   FileDirty = 1

   'initialize and exit if required
   If UBound(D,2) = 1 Then Beep : Exit Sub     'cannot delete last row
   tempR = SList(UBound(SList))
   gbGrid_OrderPoints tempR
   RowCount = tempR.nBottom - tempR.nTop + 1
   If RowCount >= UBound(D,2) Then Beep : Exit Sub  'cannot delete all rows

   'move stuff down one
   For y = 1 To UBound(D,1)
      For x = tempR.nTop+1 To UBound(D,2)- RowCount
         D(y,x) = D(y,x+RowCount)
      Next y
   Next x

   'fix DX()
   For i = 1 To UBound(DX) - RowCount
      DX(i) = DX(i+RowCount)
      If DX(i) >= tempR.nTop + 1 Then DX(i) -= RowCount
   Next i

   'ReDim D() and DX()
   ListView_SetItemCountEx(hListViewG, UBound(D,2)-RowCount, %LVSICF_noInvalidateAll) 'max rows
   ReDim Preserve D(1 To UBound(D,1),1 To UBound(D,2)-RowCount)
   MaxRow = UBound(D,2)
   ReDim Preserve DX(UBound(D,2))

   'new CurrentRow
   CurrentRow = Min(CurrentRow,UBound(D,2)-1)
   SList(UBound(SList)).nTop = CurrentRow
   SList(UBound(SList)).nBottom = CurrentRow
   SList(UBound(SList)).nLeft = CurrentCol
   SList(UBound(SList)).nRight = CurrentCol
   Control Set Focus hDlgG, %IDC_ListViewG
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_RestoreOriginalOrder    'restore rows to original order
   Local i As Long
   For i = 1 To UBound(DX) : DX(i) = i : Next i
End Sub

Sub gbGrid_RestoreOriginalOrderTop
   ReDim SO(0)
   gbGrid_ClearAllSortIcons
   gbGrid_RestoreOriginalOrder
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_UseColors
   UseColors Xor= 1
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_LockSort
   Local x,y As Long
   FileDirty = 1
   ReDim tempD(1 To UBound(D,1),1 To UBound(D,2))
   'build temp array
   For x = 1 To UBound(D,2)
      For y = 1 To UBound(D,1)
         tempD(y,x) = D(y,DX(x))
      Next y
   Next x
   'put temp array back into main array
   For x = 1 To UBound(D,2)
      For y = 1 To UBound(D,1)
         D(y,x) = tempD(y,x)
      Next y
   Next x
   gbGrid_ClearAllSortIcons
   gbGrid_RestoreOriginalOrder
   Erase SO()
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_FillRight
   Local x,y As Long, tempR As Rect
   FileDirty = 1
   tempR = SList(UBound(SList))
   gbGrid_OrderPoints tempR
   For x = tempR.nTop To tempR.nBottom
      For y = tempR.nLeft+1 To tempR.nRight
         D(y+1,DX(x+1)) = D(tempR.nLeft+1,DX(x+1))
      Next y
   Next x
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_FillDown
   Local x,y As Long, tempR As Rect
   FileDirty = 1
   tempR = SList(UBound(SList))
   gbGrid_OrderPoints tempR
   For y = tempR.nLeft To tempR.nRight
      For x = tempR.nTop+1 To tempR.nBottom
         D(y+1,DX(x+1)) = D(y+1,DX(tempR.nTop+1))
      Next x
   Next y
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_FillAll
   Local x,y As Long, tempR As Rect, temp$
   FileDirty = 1
   tempR = SList(UBound(SList))
   gbGrid_OrderPoints tempR
   temp$ = D(CurrentCol+1,CurrentRow+1)
   For y = tempR.nLeft To tempR.nRight
      For x = tempR.nTop To tempR.nBottom
         D(y+1,DX(x+1)) = temp$
      Next x
   Next y
   gbGrid_PaintBlock 0
End Sub

Sub gbGrid_Sum
   Local i,x,y As Long, tempR As Rect, Sum As Double
   For i = 1 To UBound(SList)
      tempR = SList(i)
      gbGrid_OrderPoints tempR
      For x = tempR.nTop To tempR.nBottom
         For y = tempR.nLeft To tempR.nRight
            Sum += Val(D(y+1,DX(x+1)))
         Next y
      Next x
   Next i
   Clipboard Reset
   Clipboard Set Text Str$(Sum)  'Format$(Sum,"###,###,##0.00")
   Statusbar Set Text hDlgG, %IDC_StatusBar, 3, 0, "Sum: " + Str$(Sum)  'Format$(Sum,"###,###,##0.00")
End Sub

Sub gbGrid_CreateFont
   Font New FontName, FontSize, FontAttr To hFontG
   Graphic Set Font hFontG
   Control Set Font hDlgG, %IDC_ListViewG, hFontG
   Control Set Font hDlgG, %IDC_TextBoxIP, hFontG
End Sub

Sub gbGrid_Initialize
   Local i,w As Long
   Graphic Bitmap New 5,5 To hBMP
   Graphic Attach hBMP,0
   For i = 1 To MaxCol
      w = Val(Parse$(ColWidths,"|",i))
      If w = 0 Then w = 75
      ListView Insert Column hDlgG, %IDC_ListViewG,i,Headers(i),w,0 : Next i
   gbGrid_RestoreOriginalOrder
   ListView_SetItemCountEx(hListViewG, UBound(D,2), %LVSICF_noInvalidateAll) 'max rows
   gbGrid_ResetSList
   gbGrid_CreateContextMenus
   gbGrid_CreateFont
   gbGrid_SetColumnWidths
   Control Set Color hDlgG, %IDC_TextBoxF, %Black ,EditColor
   jpGetColTypes D(), UBound(D,1), UBound(D,2)  'initialize sort routine
End Sub

Sub gbGrid_Report
   Local temp$
   temp$ += "D() (col:row): " + $Tab + Str$(UBound(D,1)) + Str$(UBound(D,2)) + $CrLf
   temp$ += "DX() (rows): " + $Tab + Str$(UBound(DX)) + $CrLf + $CrLf
   temp$ += "File " + IIf$(FileDirty,"Dirty","Not Dirty")
   gbGrid_MsgBox temp$, %MB_Ok + %MB_IconInformation + %MB_TaskModal, "Summary Report"
End Sub

Sub gbGrid_PrintSelectedCells
   On Error GoTo EndPrint
   Local i,x,y,iRows,iCol,ColStartPos,TotalRows As Long, tempR As Rect
   XPrint Attach Choose
   'get selected text
   Dim MaxColWidth(MaxCol) As Long
   For i = UBound(SList) To 1 Step -1
      tempR = SList(i)
      gbGrid_OrderPoints tempR
      iCol = 0
      For y = tempR.nLeft To tempR.nRight
         Incr iCol
         For x = tempR.nTop To tempR.nBottom
            MaxColWidth(iCol) = Max(MaxColWidth(iCol), XPrint(Text.Size.X,D(y+1,x+1)))
         Next x
      Next y
   Next i
   'print
   For i = UBound(SList) To 1 Step -1
      tempR = SList(i)
      gbGrid_OrderPoints tempR
      ColStartPos = 200
      TotalRows = iRows + 2
      iCol = 0
      For y = tempR.nLeft To tempR.nRight
         Incr iCol
         iRows = TotalRows
         For x = tempR.nTop To tempR.nBottom
            Incr iRows
            XPrint Set Pos (ColStartPos, 200 + (iRows-1) * XPrint(Text.Size.Y,"X"))
            XPrint D(y+1,x+1)
         Next x
         ColStartPos += MaxColWidth(iCol) + 200
      Next y
   Next i
   XPrint Close
EndPrint:
End Sub

Sub gbGrid_DisplayEditDialog
   Local i As Long, temp$, rc As Rect
   Dialog New Pixels, hDlgG, "Edit Record", 100, 100, 620, 275, %WS_OverlappedWindow Or %WS_Caption Or %WS_ClipChildren To hDlgE
   Dialog Set Icon hDlgE, "logo"
   Control Add Button, hDlgE, %IDE_Clear,"Clear",340,3,50,20
   Control Add Button, hDlgE, %IDE_ExitNoSave,"Exit w/o Save",400,3,90,20
   Control Add Button, hDlgE, %IDE_ExitSave,"Exit && Save",500,3,75,20
   Control Add ListView, hDlgE, %IDE_ListView, "",5,5,300,100, %WS_TabStop Or %WS_Visible Or %LVS_Report Or %LVS_SingleSel Or %LVS_ShowSelAlways, %WS_Ex_ClientEdge
   ListView Set StyleXX hDlgE, %IDE_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
   ListView Insert Column hDlgE,%IDE_ListView,1,"Field",150,0
   ListView Insert Column hDlgE,%IDE_ListView,2,"Value",9999,0
   For i = 1 To MaxCol : ListView Insert Item hDlgE,%IDE_ListView, i, 0, Headers(i) : Next i
   ReDim tempE(MaxCol)
   For i = 1 To MaxCol
      tempE(i) = D(i,DX(CurrentRow+1))
      Replace $Lf With $CrLf In tempE(i)
      temp$ = Parse$(tempE(i),$CrLf,1) + IIf$(ParseCount(tempE(i),$CrLf)>1," ...","")
      ListView Set Text hDlgE,%IDE_ListView, i, 2, temp$
   Next i
   Control Add TextBox, hDlgE, %IDE_TextBox, "Value",310,30,100,180, %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
                                          Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop, %WS_Ex_ClientEdge
   Control Set Font hDlgE, %IDE_ListView, hFontG
   Control Set Font hDlgE, %IDE_TextBox, hFontG
   Dialog Show Modal hDlgE  Call gbGrid_DlgProc()
End Sub

CallBack Function gbGrid_DlgProc() As Long
   Local w,h,iCol As Long, pNMLV As NMListView Ptr
   Static EditDirty As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         ListView Select hDlgE, %IDE_ListView, CurrentCol + 1
         ListView_SetItemState GetDlgItem(hDlgE, %IDE_ListView), CurrentCol, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
         Control Set Text hDlgE, %IDE_TextBox, tempE(CurrentCol+1)
         Dialog Post hDlgE, %WM_User+500, 0, 0
      Case %WM_User + 500
         Control Set Focus hDlgE, %IDE_TextBox
         SendMessage GetDlgItem(hDlgE,%IDE_TextBox), %EM_SetSel, 0, -1
      Case %WM_Size
         Dialog Get Client hDlgE To w,h
         Control Set Size hDlgE, %IDE_ListView,300,h-10
         Control Set Size hDlgE, %IDE_TextBox,w-315,h-35
      Case %WM_SYSCOMMAND      'trap Alt-F4 and X Button
         If ((Cb.WParam And &HFFF0) = %SC_Close) And EditDirty Then    'trap Alt-F4, X-button, WindowMenu/Close
            Select Case gbGrid_MsgBox("Record has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
               Case %IdYes
                  For iCol = 1 To MaxCol
                     Replace $CrLf With $Lf In tempE(iCol)
                     D(iCol,DX(CurrentRow+1)) = tempE(iCol)
                  Next iCol
                  EditDirty = 0   'not really needed, just to show visually what is being done
               Case %IdNo
                  EditDirty = 0   'go ahead with closing the application but do not save the results
               Case %IdCancel : Function = 1    'abort the close
            End Select
         End If
      Case %WM_Destroy
         If EditDirty Then
            For iCol = 1 To MaxCol
               Replace $CrLf With $Lf In tempE(iCol)
               D(iCol,DX(CurrentRow+1)) = tempE(iCol)
            Next iCol
         End If
         EditDirty = 0
         Control Set Focus hDlgG, %IDC_ListViewG
         gbGrid_PaintBlock 0
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel   : Dialog End hDlgE
            Case %IDE_TextBox
               Select Case Cb.CtlMsg
                  Case %EN_Change
                     ListView Get Select hDlgE, %IDE_ListView To iCol
                     Control Get Text hDlgE, %IDE_TextBox To tempE(iCol)
                     ListView Set Text hDlgE, %IDE_ListView, iCol, 2, Parse$(tempE(iCol),$CrLf,1) + IIf$(ParseCount(tempE(iCol),$CrLf)>1," ...","")
                     EditDirty = 1
               End Select
            Case %IDE_Clear
               Control Set Text hDlgE, %IDE_TextBox, ""
               EditDirty = 1
            Case %IDE_ExitSave
               Dialog End hDlgE
            Case %IDE_ExitNoSave
               EditDirty = 0
               Dialog End hDlgE
         End Select
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDE_ListView
               Select Case Cb.NmCode
                  Case %LVN_ItemChanged
                     pNMLV = Cb.LParam
                     If (@pNMLV.uChanged And %LVIF_STATE) = %LVIF_STATE Then  ' if state has changed
                         If (@pNMLV.unewstate And %LVIS_SELECTED) = %LVIS_SELECTED Then
                            ListView Get Select hDlgE, %IDE_ListView To iCol
                            Control Set Text hDlgE, %IDE_TextBox, tempE(iCol)
                        End If
                     End If
               End Select
         End Select
   End Select
End Function

Sub gbGrid_DisplayContextDialog(task$)     'task="insert
   Dialog Font "Tahoma",10,0
   Dialog New Pixels, hDlgG, Task$, 100, 100, 160,145, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hDlgX
   Dialog Set Icon hDlgX, "logo"
   If Task$ = "Insert" Then
      Control Add Option, hDlgX, %IDX_Right, "Shift Cells Right", 10,10,120,20
      Control Add Option, hDlgX, %IDX_Down, "Shift Cells Down", 10,35,120,20
   Else
      Control Add Option, hDlgX, %IDX_Right, "Shift Cells Left", 10,10,120,20
      Control Add Option, hDlgX, %IDX_Down, "Shift Cells Up", 10,35,120,20
   End If
   Control Add Option, hDlgX, %IDX_Row, "Entire Row", 10,60,120,20
   Control Add Option, hDlgX, %IDX_Col, "Entire Column", 10,85,120,20
   Control Add Button, hDlgX, %IDX_Ok, "OK", 20,115,50,20
   Control Add Button, hDlgX, %IDX_Cancel, "Cancel", 80,115,50,20
   Dialog Show Modal hDlgX Call gbGrid_ContextDlgProc()
End Sub

CallBack Function gbGrid_ContextDlgProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         XResult = XTask
         Control Set Option hDlgX, Choose(XTask,%IDX_Left,%IDX_Right,%IDX_Up,%IDX_Down,%IDX_Row,%IDX_Col), %IDX_Left, %IDX_Col
      Case %WM_Command
         Select Case Cb.Ctl
            Case %WM_SYSCOMMAND : If (Cb.WParam And &HFFF0) = %SC_Close Then XResult = -1  'trap Alt-F4 and X Button
            Case %IdCancel   : XResult = -1      : Dialog End hDlgX
            Case %IDX_Row    : XResult = %XRow
            Case %IDX_Col    : XResult = %XCol
            Case %IDX_Up     : XResult = %XUp
            Case %IDX_Down   : XResult = %XDown
            Case %IDX_Left   : XResult = %XLeft
            Case %IDX_Right  : XResult = %XRight
            Case %IDX_OK     : Dialog End hDlgX
            Case %IDX_Cancel : XTask = -1      : Dialog End hDlgX
         End Select
      Case %WM_Destroy
         Control Set Focus hDlgG, %IDC_ListViewG
   End Select
End Function

Function gbGrid_MsgBox(msg$,Flag As Long,caption$) As Long
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(gbGrid_SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
   UnhookWindowsHookEx ghHook
End Function

Function gbGrid_SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   gbGrid_CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub gbGrid_CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x,y,ww,hh As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To ww,hh
   CenterX = x + (ww-BoxX)/2
   CenterY = y + (hh-BoxY)/2
End Sub

Sub gbGrid_FileSafe
   FileDirty = 0
End Sub

Sub gbGrid_SetColumnWidths
   Local temp$, i,j,iLength As Long
   Dim cWidths(MaxCol) As Long
   For i = 1 To MaxCol
      cWidths(i) = 0
      For j = 1 To MaxRow
         cWidths(i) = Max(cWidths(i),Graphic(Text.Size.X,D(i,j))+15)
      Next j
      cWidths(i) = Max(cWidths(i), Graphic(Text.Size.X,Headers(i))+40)
      ListView Set Column hDlgG, %IDC_ListViewG, i, cWidths(i)
   Next i
End Sub
