TYPE Column_Type
    col AS LONG 'the column number
    tpe AS LONG 'type of data in column
    l AS LONG   'maximum length of data
    null AS LONG    'true if column contains nulls
END TYPE

SUB GetColTypes(dat() AS STRING, c AS LONG, r AS LONG)
    'dat is a multi dimensional array of the data in strings
    'all dimensions must be 1 based i.e 1 to x
    'c is number of cols 1 based
    'r is number of rows 1 based
    LOCAL x AS LONG 'loop counter
    LOCAL y AS LONG 'loop counter
    LOCAL z AS LONG 'string position counter
    LOCAL nd AS LONG 'not defined here
    LOCAL t AS STRING   'temp string so it can be changed
    LOCAL s() AS STRING 'for checking dates
    REDIM s(2)
    REDIM ct(1 TO c)
    FOR x = 1 TO c
        FOR y = 1 TO r
            IF RTRIM$(dat(x, y)) = "" THEN  'check for a null field
                ct(x).NULL = 1              'and set to true
            ELSE
                IF LEN(dat(x, y)) > ct(x).l THEN ct(x).l = LEN(dat(x, y)) 'get max length in column
                IF ct(x).tpe < 3 THEN   'check if column already contains not a long or double
                    nd = 0
                    t = REMOVE$(dat(x, y), ",")   'move dat to a temporary string without commas
                    FOR z = 1 TO LEN(t)
                        IF INSTR("0123456789.-", MID$(t, z, 1)) = 0 THEN
                            nd = -1
                            IF ct(x).tpe = 1 OR ct(x).tpe = 2 THEN ct(x).tpe = 0 'an entry in the column which isn't either of those
                            EXIT FOR
                        END IF
                    NEXT
                    IF nd = 0 THEN
                        IF TALLY(t, "-") > 1 THEN
                            ct(x).tpe = 0   'could be a date
                            nd = -1
                        ELSEIF TALLY(t, "-") = 1 THEN
                            IF LEFT$(t, 1) <> "-" THEN
                                ct(x).tpe = 8   'not a negative number so set as string
                                nd = -1
                            END IF
                        END IF
                    END IF
                    IF nd = 0 THEN 'can be long or double
                        IF INSTR(t, ".") = 0 THEN 'a long?
                            IF ct(x).tpe = 0 THEN ct(x).tpe = 1
                        ELSE
                            IF TALLY(t, ".") > 1 THEN   'could be an IP address
                                ct(x).tpe = 8    'so set as string
                            ELSE
                                IF ct(x).tpe < 2 THEN ct(x).tpe = 3 'a long
                            END IF
                        END IF
                    END IF
                END IF
                IF ct(x).tpe < 4 THEN   'check for formatted currency
                    'could be improved to check for CR or DB etc so no negatve amounts at this time
                    nd = 0
                    t = REMOVE$(dat(x, y), ",")   'move dat to a temporary string without commas
                    IF LEFT$(t, 1) = "$" THEN
                        t = RIGHT$(t, LEN(t) - 1)
                        FOR z = 1 TO LEN(t)
                            IF INSTR("0123456789.", MID$(t, z, 1)) = 0 THEN
                                nd = -1
                                ct(x).tpe = 0   'not currency so undefined
                                EXIT FOR
                            END IF
                        NEXT
                        IF nd = 0 THEN ct(x).tpe = 3    'is currency
                    END IF
                END IF
                IF ct(x).tpe = 0 OR (ct(x).tpe > 3 AND ct(x).tpe < 8) THEN  'check for dates
                    IF TALLY(dat(x, y), "-") = 2 THEN
                        RESET s()
                        PARSE dat(x, y), s(), "-"
                        IF VAL(s(0)) < 13 AND VAL(s(1)) > 12 THEN   'is american format
                            ct(x).tpe = 7
                        ELSEIF VAL(s(0)) > 12 AND VAL(s(1)) < 13 THEN   'is british format
                            ct(x).tpe = 6
                        ELSE
                            IF ct(x).tpe <> 6 THEN ct(x).tpe = 7   'default to american, change to suit
                        END IF
                    ELSEIF TALLY(dat(x, y), "/") = 2 THEN
                        RESET s()
                        PARSE dat(x, y), s(), "/"
                        IF VAL(s(0)) < 13 AND VAL(s(1)) > 12 THEN   'is american format
                            ct(x).tpe = 5
                        ELSEIF VAL(s(0)) > 12 AND VAL(s(1)) < 13 THEN   'is british format
                            ct(x).tpe = 4
                        ELSE
                            IF ct(x).tpe <> 4 THEN ct(x).tpe = 5   'default to american, change to suit
                        END IF
                    ELSE
                        ct(x).tpe = 8
                    END IF
                END IF
                IF ct(x).tpe = 0 THEN ct(x).tpe = 8 'none of above so a string
            END IF
        NEXT
    NEXT
    FOR x = 1 TO c
        IF ct(x).tpe = 8 THEN   'make string lengths a multiple of 4
            IF ct(x).l MOD 4 <> 0 THEN ct(x).l += 4 - (ct(x).l MOD 4)
        END IF
    NEXT
END SUB

    '**** calculate working space needed and allocate ****
    FOR x = 0 TO UBOUND(so)
        SELECT CASE ct(so(x).col).tpe
            CASE 8 'strings are most likely
                sl += ct(so(x).col).l
            CASE 1  'longs
                sl += 4
            CASE 2, 3   'doubles and currency
                sl += 8
            CASE 4 TO 7 'dates will be sorted as longs
                sl += 4
        END SELECT
        IF ct(so(x).col).tpe <> 8 AND ct(so(x).col).NULL THEN sl += 4   'add space for the hidden null fields
    NEXT
    sl += 4 'and room for the indexes
    REDIM b(r * sl - 1)
    '**** work space allocated so now we load it ****
    FOR y = 1 TO r
        FOR x = 0 TO UBOUND(so)
            IF ct(so(x).col).tpe <> 8 AND ct(so(x).col).NULL THEN'column has nulls so insert null sort field before
                wp = VARPTR(b(bc))      'the columns actual columnd data
                IF RTRIM$(dat(so(x).col, y)) = "" THEN v = 0 ELSE v = 1
                IF so(x).dir THEN v = NOT v 'descending
                @wp = v
                bc += 4
            END IF
            SELECT CASE ct(so(x).col).tpe
                CASE 8 'strings are most likely
                    sp = STRPTR(dat(so(x).col, y))
                    bp = sp
                    wp = VARPTR(b(bc))
                    IF so(x).dir = 0 THEN    'ascending
                        FOR z = 0 TO LEN(dat(so(x).col, y)) - 1
                            b(bc) = @bp[z]
                            INCR bc
                        NEXT
                        FOR w = z TO ct(so(x).col).L - 1
                            b(bc) = 0
                            INCR bc
                        NEXT
                    ELSE    'descending
                        FOR z = 0 TO LEN(dat(so(x).col, y)) - 1
                            b(bc) = NOT @bp[z]
                            INCR bc
                        NEXT
                        FOR w = z TO ct(so(x).col).L - 1
                            b(bc) = &HFF
                            INCR bc
                        NEXT
                    END IF
                    v = ct(so(x).col).L \ 4
                    !pushad     'and swap every 4 bytes to sort as dwords
                    !mov esi, wp
                    !mov ecx, v
                    swplp:
                    !mov eax, [esi] 'move 4 characters to eax
                    !bswap eax      'then swap them so they can be compared 4 at a time
                    !mov [esi], eax
                    !add esi, 4
                    !dec ecx
                    !jnz swplp
                    !popad
                CASE 1  'longs
                    wp = VARPTR(b(bc))
                    t = REMOVE$(dat(so(x).col, y), ",")
                    v = VAL(t)
                    BIT TOGGLE v, 31    'so we can sort as dwords
                    IF so(x).dir THEN v = NOT v 'descending
                    @wp = v
                    bc += 4
                CASE 2  'doubles
                    wp = VARPTR(b(bc))
                    t = REMOVE$(dat(so(x).col, y), ",")
                    dbr = VAL(t)
                    dp = VARPTR(dbr)
                    wp1 = dp
                    IF dbr < 0 THEN
                        @wp1 = NOT @wp1
                        @wp1[1] = NOT @wp1[1]
                    ELSE
                        BIT TOGGLE @wp1, 31 'reverse sign bit
                    END IF
                    IF so(x).dir THEN 'descending
                        @wp1 = NOT @wp1
                        @wp1[1] = NOT @wp1[1]
                    END IF
                    @wp = @wp1[1]   'and load with dwords reversed
                    @wp[1] = @wp1
                    bc += 8
                CASE 3  'currency but sort as double
                    wp = VARPTR(b(bc))
                    t = REMOVE$(dat(so(x).col, y), ANY ",$")
                    dbr = VAL(t)
                    dp = VARPTR(dbr)
                    wp1 = dp
                    IF dbr < 0 THEN
                        @wp1 = NOT @wp1
                        @wp1[1] = NOT @wp1[1]
                    ELSE
                        BIT TOGGLE @wp1, 31 'reverse sign bit
                    END IF
                    IF so(x).dir THEN 'descending
                        @wp1 = NOT @wp1
                        @wp1[1] = NOT @wp1[1]
                    END IF
                    @wp = @wp1[1]   'and load with dwords reversed
                    @wp[1] = @wp1
                    bc += 8
                CASE 4  'date d/m/yyyy sort as long
                    RESET s()
                    wp = VARPTR(b(bc))
                    IF ct(so(x).col).NULL AND RTRIM$(dat(so(x).col, y)) = "" THEN
                        v = 0   'so we dont get errors trying to convert date to double
                    ELSE
                        PARSE dat(so(x).col, y), s(), "/"
                        st.wday = VAL(s(0))
                        st.wmonth = VAL(s(1))
                        st.wyear = VAL(s(2))
                        IF st.wyear < 100 THEN st.wyear += 2000
                        er = systemtimetovarianttime(st, dbr)
                        IF er = 0 THEN
                            ? "invalid date " & dat(so(x).col, y)
                            v = 0
                        ELSE
                            v = dbr
                        END IF
                        BIT TOGGLE v, 31    'so we can sort as dwords
                        IF so(x).dir THEN v = NOT v 'descending
                    END IF
                    @wp = v
                    bc +=4
                CASE 5  'date m/d/yyyy sort as long
                    RESET s()
                    wp = VARPTR(b(bc))
                    IF ct(so(x).col).NULL AND RTRIM$(dat(so(x).col, y)) = "" THEN
                        v = 0   'so we dont get errors trying to convert date to double
                    ELSE
                        PARSE dat(so(x).col, y), s(), "/"
                        st.wday = VAL(s(1))
                        st.wmonth = VAL(s(0))
                        st.wyear = VAL(s(2))
                        IF st.wyear < 100 THEN st.wyear += 2000
                        er = systemtimetovarianttime(st, dbr)
                        IF er = 0 THEN
                            ? "invalid date " & dat(so(x).col, y)
                            v = 0
                        ELSE
                            v = dbr
                        END IF
                        BIT TOGGLE v, 31    'so we can sort as dwords
                        IF so(x).dir THEN v = NOT v 'descending
                    END IF
                    @wp = v
                    bc +=4
                CASE 6  'date d-m-yyyy sort as long
                    RESET s()
                    wp = VARPTR(b(bc))
                    IF ct(so(x).col).NULL AND RTRIM$(dat(so(x).col, y)) = "" THEN
                        v = 0   'so we dont get errors trying to convert date to double
                    ELSE
                        PARSE dat(so(x).col, y), s(), "-"
                        st.wday = VAL(s(0))
                        st.wmonth = VAL(s(1))
                        st.wyear = VAL(s(2))
                        IF st.wyear < 100 THEN st.wyear += 2000
                        er = systemtimetovarianttime(st, dbr)
                        IF er = 0 THEN
                            ? "invalid date " & dat(so(x).col, y)
                            v = 0
                        ELSE
                            v = dbr
                        END IF
                        BIT TOGGLE v, 31    'so we can sort as dwords
                        IF so(x).dir THEN v = NOT v 'descending
                    END IF
                    @wp = v
                    bc +=4
                CASE 7  'date m-d-yyyy sort as long
                    RESET s()
                    wp = VARPTR(b(bc))
                    IF ct(so(x).col).NULL AND RTRIM$(dat(so(x).col, y)) = "" THEN
                        v = 0   'so we dont get errors trying to convert date to double
                    ELSE
                        PARSE dat(so(x).col, y), s(), "-"
                        st.wday = VAL(s(1))
                        st.wmonth = VAL(s(0))
                        st.wyear = VAL(s(2))
                        IF st.wyear < 100 THEN st.wyear += 2000
                        er = systemtimetovarianttime(st, dbr)
                        IF er = 0 THEN
                            ? "invalid date " & dat(so(x).col, y)
                            v = 0
                        ELSE
                            v = dbr
                        END IF
                        BIT TOGGLE v, 31    'so we can sort as dwords
                        IF so(x).dir THEN v = NOT v 'descending
                    END IF
                    @wp = v
                    bc +=4
            END SELECT
        NEXT
