'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbcsveditor.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode=1
#Include "Win32API.inc"
#Include "cgdiplus.inc"

$ver = "1.4"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "icons\csveditor.ico"
#Resource Icon xup "icons\sortascending.ico"
#Resource Icon xdown "icons\sortdescending.ico"
#Resource Icon xnosort "icons\nosort.ico"
#Resource Icon xsearch "icons\find.ico"

Enum Equates Singular
   IDC_Toolbar = 500
   IDC_Statusbar
   IDC_LocalHelp
   ID_Timer

   IDM_LockSort
   IDM_SetColWidth
   IDM_Sep

   IDM_Test

   IDM_New
   IDM_Open
   IDM_Save
   IDM_SaveAs
   IDM_Exit
   IDM_About

   IDM_Find
   IDM_Reload
   IDM_UnSort
   IDM_Resort
   IDM_TrueImageSize
   IDM_CaseSensitive
   IDM_Font
   IDM_Eyes
   IDM_Settings

   IDM_ClearRecent
   IDM_RecentFile = 1000
End Enum

'handles
Global hDlg  As Dword

'working variables
Global D(), Headers()                   As String
Global DX(), FileDirty                  As Long
Global hMenuSettings,hMenuRecent,hMenu  As Dword
Global OldFile                          As DirData

'INI variables
Global FileName,RecentFiles(),RecentWidths() As WStringZ * %Max_Path

#Include "files\gbgrid_sort.inc"
#Include "files\gbcsveditor.inc"

Function PBMain() As Long
   Dialog Font "Tahoma", 10
   Dialog New Pixels, 0, "gbCSVEditor  v" + $ver,300,100,580,800, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   hDlgG = hDlg
   Dialog Set Icon hDlg, "logo"
   gbGrid_CreateListView
   gbGrid_CreateStatusBar
   Dialog Show Modal hDlg Call DlgProc
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(10)
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F  : ac(c).cmd   = %IDM_Find            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G  : ac(c).cmd   = %IDM_gridJump        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N  : ac(c).cmd   = %IDM_New             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_O  : ac(c).cmd   = %IDM_Open            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd   = %IDM_gridEditDialog  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd   = %IDM_Save            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd   = %IDM_Test            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_U  : ac(c).cmd   = %IDM_gridUnselect    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W  : ac(c).cmd   = %IDM_SetColWidth     : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDM_About           : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd   = %IDM_Find            : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Loc hDlg, %IDC_ListViewG, 0,0
   Control Set Size hDlg, %IDC_ListViewG, w, h-23
   Control ReDraw hDlg, %IDC_StatusBar
End Sub

Sub DisplayLocalHelp
   Local temp$, hMsgBox As Dword, hFontM As Dword, w,h As Long
   temp$ +=  "  gbCSVEditor  v" + $Ver + "  2014 Gary Beene" + $CrLf
   temp$ +=  "  ---" + $CrLf
   temp$ +=  "  F2, Ctrl-E, Dbl-Click and ENTER initiate editing at default location" + $CrLf
   temp$ +=  "  Ctrl-R open Edit Record dialog" + $CrLf
   temp$ +=  "  ENTER may alternately be used for navigation" + $CrLf
   temp$ +=  "  ---" + $CrLf
   temp$ +=  "  ENTER ends editing" + $CrLf
   temp$ +=  "  ESC, Ctrl-K, click outside cell, CancelEdit (Toolbar) cancel editing" + $CrLf
   temp$ +=  "  ---" + $CrLf
   temp$ +=  "  F1    ...  Help" + $CrLf
   temp$ +=  "  F2    ...  Enter Edit Mode" + $CrLf
   temp$ +=  "  F3    ...  Find Dialog" + $CrLf
   temp$ +=  "  Ctrl-D ...  Toggle ENTER behavior" + $CrLf
   temp$ +=  "  Ctrl-E ...  Enter Edit Mode" + $CrLf
   temp$ +=  "  Ctrl-F ...  Find & Replace Dialog" + $CrLf
   temp$ +=  "  Ctrl-G ...  GoTo Row" + $CrLf
   temp$ +=  "  Ctrl-O ...  Open File" + $CrLf
   temp$ +=  "  Ctrl-R ...  Open Edit Record Dialog" + $CrLf
   temp$ +=  "  Ctrl-S ...  Save As" + $CrLf
   temp$ +=  "  Ctrl-W ...  Resize Columns to Fit Content" + $CrLf

   Font New FontName, FontSize, FontAttr To hFontM

   w = FontSize/10 * 430 : h = 380
   Dialog New Pixels, hDlgG, "Local Help", 25, 25, w,h, %WS_SysMenu To hMsgBox
   Dialog Set Icon hMsgBox, "logo"
   Control Add TextBox, hMsgBox, %IDC_LocalHelp, temp$,10,10, w-20,h-20, %WS_Child Or %WS_Visible Or %ES_MultiLine Or %ES_ReadOnly, %WS_Ex_ClientEdge
   Control Set Font hMsgBox, %IDC_LocalHelp, hFontM
   Control Post hMsgBox, %IDC_LocalHelp, %EM_SetSel, -1, 0
   Dialog Show Modal hMsgBox
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long, xxResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "200", xxResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "200", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xxResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "1000", xxResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xxResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Courier New", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FindThis", "", FindThis, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SortOrder", "", SortOrder, %Max_Path, INIFileName
      For x = 0 To 9
         Getprivateprofilestring "All", "RF"+Trim$(x), "", RecentFiles(x), %Max_Path, INIFileName
         Getprivateprofilestring "All", "RW"+Trim$(x), "", RecentWidths(x), %Max_Path, INIFileName
      Next x

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "9", temp, %Max_Path, INIFileName: FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "CurrentRow", "0", temp, %Max_Path, INIFileName:  CurrentRow = Val(temp)
      Getprivateprofilestring "All", "TrueImageSize", "0", temp, %Max_Path, INIFileName:  TrueImageSize = Val(temp)
      Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)

      'get EditDialog info
      Getprivateprofilestring "All", "ELeft", "100", temp, %Max_Path, INIFileName:  ELeft = Val(temp)
      Getprivateprofilestring "All", "ETop", "100", temp, %Max_Path, INIFileName:  ETop = Val(temp)
      Getprivateprofilestring "All", "EWidth", "400", temp, %Max_Path, INIFileName:  EWidth = Val(temp)
      Getprivateprofilestring "All", "EHeight", "400", temp, %Max_Path, INIFileName:  EHeight = Val(temp)
      Getprivateprofilestring "All", "ETopTB", "200", temp, %Max_Path, INIFileName:  ETopTB = Val(temp)

      'custom colors
      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "FindThis",FindThis, INIFileName
      WritePrivateProfileString "All", "SortOrder",SortOrder, INIFileName
      For x = 0 To 9
         WritePrivateProfileString "All", "RF"+Trim$(x),RecentFiles(x), INIFileName
         WritePrivateProfileString "All", "RW"+Trim$(x),RecentWidths(x), INIFileName
      Next x

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "CurrentRow", Str$(CurrentRow), INIFileName
      WritePrivateProfileString "All", "TrueImageSize", Str$(TrueImageSize), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", Str$(CaseSensitive), INIFileName

      'edit dialog location/position
      WritePrivateProfileString "All", "ELeft", Str$(ELeft), INIFileName
      WritePrivateProfileString "All", "ETop", Str$(ETop), INIFileName
      WritePrivateProfileString "All", "EWidth", Str$(EWidth), INIFileName
      WritePrivateProfileString "All", "EHeight", Str$(EHeight), INIFileName
      WritePrivateProfileString "All", "ETopTB", Str$(ETopTB), INIFileName

      'custom colors
      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next x
   End If
End Sub


Sub SetMenusAndToolbar
   'Menus
    Menu Set State hMenuSettings, ByCmd %IDM_TrueImageSize,  IIf(TrueImageSize,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hMenuSettings, ByCmd %IDM_CaseSensitive,  IIf(CaseSensitive,%MFS_Checked,0) Or %MFS_Enabled
End Sub

Sub SaveFileAs
   Local hParent As Dword
   Local title$, folder$, filter$, start$, defaultext$, flags&, filevar$, countvar&
   hParent = hDlg              'if not parent, use 0 or %hWnd_Desktop
   title$ = "Save File As"     'if "", then "Save As" is used
   folder$ = FileName   'if "", Then current directory is used
   filter$ = Chr$("Data Files (csv/psv/tsv)", 0, "*.csv;*.psv;*.tsv", 0)
   start$ = FileName    'starting filename
   defaultext$ = Right$(FileName,3)
   flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
   Display Savefile hParent, 100, 100, title$, folder$, filter$, start$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then
      FileName = filevar$
      AddFileNameToRecentFiles
      CreateRecentMenu
      SaveFileName
   End If
End Sub

Sub SaveFileName
    Local iRow, iCol As Long, Sep As String, tmp$, temp$

KillTimer hDlg, %ID_Timer

    Select Case Right$(LCase$(FileName),3)
       Case "psv" : Sep = "|"
       Case "csv" : Sep = ","
       Case "tsv" : Sep = $Tab
    End Select

    'Open file and save data.
    Open FileName For Output As #1

    'Get field names.
    For iCol = 1 To UBound(Headers)
       tmp$ += Headers(iCol) + Sep
    Next i
    tmp$ = Trim$(tmp$,Sep)
    Print #1, tmp$

    'Get records.
    For iRow = 1 To MaxRow
       temp$ = ""
       For iCol = 1 To MaxCol
           If InStr(D(iCol,iRow), Any $Dq + $Cr + Sep) Then
               'Surround with quotes because fields include:
               'double quotes, carriage returns or pipes.
               tmp$ = D(iCol,iRow)
               'Double any double quotes.
               Replace $Dq With $Dq + $Dq In tmp$
               'Replace carriage return line feeds with just line feeds.
               Replace $CrLf With $Lf In tmp$
               temp$ = temp$ + $Dq + tmp$ + $Dq + Sep
           Else
               'No quotes needed.
               temp$ = temp$ + D(iCol,iRow) + Sep
           End If
       Next i
       Print #1, Trim$(temp$,Sep)
    Next lRow
    Close #1

temp$ = Dir$(FileName, 0, To OldFile)
SetTimer hDlg, %ID_Timer, 1000, ByVal %Null

    gbGrid_FileSafe
End Sub

Function LoadFileNameToD() As Long
   Local i,iRow,LineSeparator As Long
   Local temp$, pSrc As Byte Ptr
   Local szDst     As AsciiZ * 4096
   Local pDst      As Byte Ptr
   Local lQuote    As Long
   Local lFldCnt   As Long

   'stop monitoring
   KillTimer hDlg, %ID_Timer

   'Open File, get Row and Column Count, Build Array
   Open FileName For Input As #1
   FileScan #1, Records To MaxRow
   If MaxRow < 2 Then
      temp$ = ""
      MaxRow = 1
   Else
      Decr MaxRow
      Line Input #1, temp$
   End If
   Close #1

   'Get ColCount and set line separator
   Select Case Right$(LCase$(FileName),3)
      Case "psv" : MaxCol = ParseCount(temp$,"|")  : LineSeparator = Asc("|")  '124
      Case "csv" : MaxCol = ParseCount(temp$,",")  : LineSeparator = Asc(",")  '44
      Case "tsv" : MaxCol = ParseCount(temp$,$Tab) : LineSeparator = Asc($Tab) '9
   End Select

   'Headers
   ReDim Headers(1 To MaxCol)
   For i = 1 To MaxCol
      Headers(i) = Parse$(temp$,Chr$(LineSeparator),i)
   Next i

   ListView_SetItemCountEx(hListViewG, 0, %LVSICF_noInvalidateAll) 'max rows

   'initialize arrays
   ReDim D(1 To MaxCol ,1 To MaxRow)    '1st row has column header information, not data
   ReDim DX(MaxRow)

   'Open File, get all text
   If Len(temp$) Then
      Open FileName For Binary As #1
      Get$ #1, Lof(1), temp$
      Close #1
   Else
      temp$ = $CrLf + "File Empty"
   End If

   'Remove 1st line because is not data
   i = InStr(temp$,$CrLf)     'end of first line - CRLF required
   temp$ = Mid$(temp$,i+2)   'take out the 1st line
   If Right$(temp$,2) <> $CrLf Then temp$ += $CrLf  'must end in $crlf

   'Load data from file
   pSrc = StrPtr(temp$)
   Do While @pSrc
       Incr iRow
       DX(iRow) = iRow
       szDst = "" : lQuote = 0 : lFldCnt = 0
       pDst = VarPtr(szDst)
       'parse through the next line
       Do While @pSrc
           Select Case @pSrc
               Case 13     'Carriage Return.
                   If lQuote Then
                       'Within quotes, so copy.
                       @pDst = @pSrc
                       Incr pDst
                       Incr pSrc
                       If @pSrc = 10 Then
                           'Copy Line Feed also.
                           @pDst = @pSrc
                           Incr pDst
                           Incr pSrc
                       Else
                           'Add Line Feed anyway.
                           @pDst = 10
                           Incr pDst
                       End If
                   Else
                       'Not within quotes, so end of record.
                       Incr pSrc
                       If @pSrc = 10 Then
                           'Move past line break.
                           Incr pSrc
                       End If
                       'End field.
                       @pDst = %NULL
                       D(lFldCnt+1,iRow) = szDst
                       Exit Do
                   End If

               Case 10     'Line Feed.
                   If lQuote Then
                       'Add Carriage Return before Line Feed.
                       @pDst = 13
                       Incr pDst
                       @pDst = @pSrc
                       Incr pDst
                       Incr pSrc
                   End If

               Case 34     'Double Quote (").
                   lQuote = Not lQuote
                   If lQuote = %FALSE And @pSrc[1] = 34 Then
                       'Next character is also a double quote, so copy one.
                       @pDst = @pSrc
                       Incr pDst
                       Incr pSrc
                       'Skip second double quote.
                       Incr pSrc
                       lQuote = Not lQuote
                   Else
                       'Skip double quote.
                       Incr pSrc
                   End If

               Case LineSeparator
                   If lQuote Then
                       'Within quotes, so copy.
                       @pDst = @pSrc
                       Incr pDst
                       Incr pSrc
                   Else
                       'End of field.
                       @pDst = %NULL
                       D(lFldCnt+1,iRow) = szDst
                       'Prepare for next field.
                       pDst = VarPtr(szDst)
                       'Increment field count.
                       Incr lFldCnt
                       Incr pSrc
                   End If

               Case Else
                   'Copy text.
                   @pDst = @pSrc
                   Incr pDst
                   Incr pSrc
           End Select
       Loop
   Loop

   Dialog Set Text hDlg, "gbCSVEditor   v" + $ver + "     " + FileName
   temp$ = Dir$(FileName, 0, To OldFile)
   SetTimer hDlg, %ID_Timer, 1000, ByVal %Null
   gbGrid_FileSafe
End Function

Sub MonitorFileDate
   Local temp$, tempFile As DirData
   If IsFile(FileName) Then
      temp$ = Dir$(FileName, 0, To tempFile)
      If tempFile.LastWriteTime <> OldFile.LastWriteTime Then
         KillTimer hDlg, %ID_Timer
         Select Case MsgBox ("File has changed. Reload?", %MB_YesNo Or %MB_TaskModal Or %MB_IconExclamation, "File Changed")
            Case %IdYes
               ReloadFileName
            Case %IdNo  'no action
         End Select
         OldFile = tempFile
         SetTimer hDlg, %ID_Timer, 1000, ByVal %Null
      End If
   End If
End Sub

Sub OpenExistingFile(task$)
   Local temp$
   temp$ = FileName
   If task$ = "all" Then
      If SelectFileToLoad = 0 Then Exit Sub  'load file to D(). also, set #columns. 0=no file selected
      gbGrid_EraseColWidths
   End If
   If IsFalse IsFile(FileName) Then Exit Sub
   ListView_SetItemCountEx(hListViewG, 0, %LVSICF_noInvalidateAll) 'max rows
   gbGrid_CreateListView
   LoadFileNameToD
   gbGrid_Initialize
   gbGrid_EraseSortOrder
   gbGrid_UpdateTextBoxAndStatusBar
   gbGrid_FileSafe
   Control Set Focus hDlg, %IDC_ListViewG
End Sub

Sub ReloadFileName
   gbGrid_GetColWidths
   gbGrid_CreateListView
   If IsFile(FileName) Then
      OpenExistingFile "noselect and not erase colwidths"
   Else
      gbGrid_CreateFakeData
      gbGrid_Initialize
      gbGrid_UpdateTextBoxAndStatusBar
      Dialog Set Text hDlg, "gbCSVEditor   v" + $ver
      Control Set Focus hDlgG, %IDC_ListViewG
   End If
   gbGrid_ApplyColWidths
   gbGrid_FileSafe
End Sub

Function SelectFileToLoad As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Data Files (csv/psv/tsv)" + $Nul + "*.csv;*.psv;*.tsv" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$ + "data")     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       If FileDirty Then    'trap Alt-F4, X-button, WindowMenu/Close
          Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
             Case %IdYes    : SaveFileName : FileName = filevar$ : Function = 1 'continue and save
             Case %IdNo     :                FileName = filevar$ : Function = 1 'continue but not save
             Case %IdCancel : Function = 0                                      'abort the close
          End Select
       Else
          FileName = filevar$ : Function = 1 'continue and save
       End If
    End If
End Function

CallBack Function DlgProc() As Long
   Local temp$, LVData As NM_ListView
   Local qStart, qStop  As Quad
   Static qFreq As Quad

   Select Case Cb.Msg
      Case %WM_InitDialog
         QueryPerformanceFrequency qFreq
         'steps that do not need INI values
         BuildAcceleratorTable
         If IsFolder (Exe.Path$ + "data") = %False Then MkDir Exe.Path$ + "data"
         'read INI values
         ReDim RecentFiles(9), RecentWidths(9)
         settings_ini "get"
         CreateMainMenu
         FileName = RecentFiles(0)
         ColWidths = RecentWidths(0)
         'load file data or fake data
         If IsFile(FileName) Then
            LoadFileNameToD
         Else
            gbGrid_CreateFakeData
         End If
         gbGrid_Initialize
         If Len(SortOrder) Then gbGrid_BackupSortOrderFromString : gbGrid_RestoreSortOrder

         SetMenusandToolbar
         'prepare to show dialog
         Control Set Focus hDlgG, %IDC_ListViewG
         Dialog Post hDlg, %WM_User+500, 0, 0

      Case %WM_User+500
         If Len(ColWidths) = 0 Then gbGrid_CalculateColumnWidths :
         gbGrid_ApplyColWidths
         gbGrid_UpdateTextBoxAndStatusbar
         gbGrid_EnsureVisibleCell CurrentRow

      Case %WM_Timer    : MonitorFileDate
      Case %WM_Destroy
         KillTimer hDlg, %ID_Timer
         gbGrid_GetSortOrder
         gbGrid_Destroy
         RecentFiles(0)  = FileName
         RecentWidths(0) = ColWidths
         settings_ini "save"
      Case %WM_SysCommand
         If ((Cb.WParam And &HFFF0) = %SC_Close) And FileDirty Then    'trap Alt-F4, X-button, WindowMenu/Close
            Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
               Case %IdYes    : SaveFileAs
               Case %IdNo     'go ahead with closing the application
               Case %IdCancel : Function = 1   'abort the close
            End Select
         End If
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Save            : SaveFileName
            Case %IDM_SaveAs          : SaveFileAs
            Case %IDM_Exit            : Dialog End hDlg
            Case %IDM_New
               If FileDirty Then
                  Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Open File")
                     Case %IdYes    : SaveFileName
                     Case %IdNo     'go ahead with opening a file
                     Case %IdCancel : Exit Select  'abort the open
                  End Select
               End If
               If IsFile(FileName) Then
                  FileName = Exe.Path$ + "files\default" + Right$(FileName,4)
               Else
                  FileName = Exe.Path$ + "files\default.csv"
               End If
               Open FileName For Output As #1 : Close #1  'create empty file
               OpenExistingFile "notall"
               If Len(ColWidths) Then gbGrid_CalculateColumnWidths :
               gbGrid_ApplyColWidths
               ResizeWindow : SetMenusAndToolbar : gbGrid_FileSafe
               AddFileNameToRecentFiles : CreateRecentMenu

            Case %IDM_Open
               If FileDirty Then
                  Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Open File")
                     Case %IdYes    : SaveFileName
                     Case %IdNo     'go ahead with opening a file
                     Case %IdCancel : Exit Select  'abort the open
                  End Select
               End If
               OpenExistingFile "all"
               If Len(ColWidths) Then gbGrid_CalculateColumnWidths :
               gbGrid_ApplyColWidths
               AddFileNameToRecentFiles
               CreateRecentMenu
               ResizeWindow : SetMenusAndToolbar : gbGrid_FileSafe

            Case %IDM_Reload
               If FileDirty Then
                  Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
                     Case %IdYes      : SaveFileName
                     Case %IdNo       'no action
                     Case %IdCancel   : Function = 0 : Exit Function  'abort the close
                  End Select
               End If
               gbGrid_BackupSortOrder
               gbGrid_RestoreOriginalOrderTop
               ReloadFileName
               ResizeWindow : SetMenusAndToolbar : gbGrid_FileSafe
               gbGrid_RestoreSortOrder

            Case %IDM_RecentFile To %IDM_RecentFile+9
               If FileDirty Then
                  Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
                     Case %IdYes      : SaveFileName
                     Case %IdNo       'no action
                     Case %IdCancel   : Function = 0 : Exit Function  'abort the close
                  End Select
               End If
               gbGrid_BackupSortOrder
               gbGrid_RestoreOriginalOrderTop
               FileName = RecentFiles(Cb.Ctl-%IDM_RecentFile)
               ColWidths = RecentWidths(Cb.Ctl-%IDM_RecentFile)
               AddFileNameToRecentFiles : CreateRecentMenu
               ReloadFileName
               ResizeWindow : SetMenusAndToolbar : gbGrid_FileSafe
               gbGrid_RestoreSortOrder

            Case %IDM_ClearRecent
               ReDim RecentFiles(9), RecentWidths(9)
               RecentFiles(0) = FileName
               RecentWidths(0) = ColWidths
               CreateRecentMenu

            Case %IDM_UnSort            : gbGrid_BackupSortOrder : gbGrid_RestoreOriginalOrderTop
            Case %IDM_ReSort            : gbGrid_RestoreSortOrder
            Case %IDM_TrueImageSize     : gbGrid_TrueImageSize : SetMenusAndToolbar
            Case %IDM_CaseSensitive     : gbGrid_CaseSensitive : SetMenusAndToolbar
            Case %IDM_Font              : gbGrid_Font : gbGrid_CalculateColumnWidths : gbgrid_ApplyColWidths
            Case %IDM_Find              : gbSearch_DisplaySearchDialog
            Case %IDM_Eyes              : gbGrid_EnsureVisibleCell(CurrentRow)
            Case %IDM_Settings          : gbGrid_Report

            Case %IDM_gridUnselect      : gbGrid_Unselect
            Case %IdOk                  : gbGrid_IDOK

            Case %IDM_gridInsertRow     : gbGrid_InsertRow ': gbGrid_Edit(0)
            Case %IDM_gridDeleteRow     : gbGrid_DeleteRow

            Case %IDM_gridMoveRowUp     : gbGrid_MoveRowUp
            Case %IDM_gridMoveRowDown   : gbGrid_MoveRowDown

            Case %IDM_gridRestoreOrder  : gbGrid_RestoreOriginalOrderTop

            Case %IDM_gridInsertCol     : gbGrid_InsertCol
            Case %IDM_gridDeleteCol     : gbGrid_DeleteCol
            Case %IDM_gridSetHeaderText : gbGrid_SetHeaderText

            Case %IDM_gridJump          : gbGrid_Jump
            Case %IDM_gridVisible       : gbGrid_EnsureVisibleCell(CurrentRow)
            Case %IDM_gridEdit          : gbGrid_Edit(0)
            Case %IDM_About             : DisplayLocalHelp

            Case %IDM_LockSort          : gbGrid_LockSort
            Case %IDM_SetColWidth       : gbGrid_CalculateColumnWidths : gbGrid_ApplyColWidths
            Case %IDM_Test              : gbGrid_Redraw

            Case %IDM_gridSetHeaderText : gbGrid_SetHeaderText
            Case %IDM_gridEditDialog    : gbGrid_DisplayEditDialog

            Case %IDM_gridCutT        : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_gridCopyT       : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_gridPasteT      : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_gridDeleteT     : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDM_gridSelectImageT : gbGrid_NewImage

         End Select
      Case %WM_Size : ReSizeWindow

      Case %WM_Notify
 Select Case Cb.NmId
            Case %IDC_ListViewG
               Select Case Cb.NmCode
                  Case %LVN_ItemChanged  : gbGrid_SetCurrentRow : gbGrid_UpdateTextBoxAndStatusBar
                  Case %LVN_GetDispInfo : gbGrid_GetDispInfo(Cb.LParam)     'notification to ask for data
                  Case %NM_DblClk       : gbGrid_Edit(0)
                  Case %LVN_ColumnClick
                     QueryPerformanceCounter qStart
                     Type Set LVData = Cb.NmHdr$(SizeOf(LVdata))
                     gbGrid_ColumnClick(LVData.iSubItem+1)
                     QueryPerformanceCounter qStop
                     Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, gbGrid_STitles + "    #Lines: " + Str$(UBound(D,2)) + "    " + Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
               End Select
         End Select
   End Select
End Function

Sub CreateRecentMenu
   Local i As Long
   For i = 0 To 9 : Menu Delete hMenuRecent, ByCmd %IDM_RecentFile+i : Next i
   For i = 0 To 9
      If Len(RecentFiles(i)) Then Menu Add String, hMenuRecent, RecentFiles(i), %IDM_RecentFile+i, %MF_Enabled
   Next i
End Sub

Sub CreateMainMenu
   Local hMenuFile,hMenuRecord,hMenuHelp As Dword

   Menu New Bar To hMenu
   Menu New PopUp To hMenuFile
   Menu New PopUp To hMenuRecent
   Menu New PopUp To hMenuRecord
   Menu New PopUp To hMenuSettings
   Menu New PopUp To hMenuHelp


   'Create File + Children -------------------------
   Menu Add PopUp, hMenu, "&File", hMenuFile, %MF_Enabled
   Menu Add String, hMenuFile, "&New" + $Tab + "Ctrl-N", %IDM_New, %MF_Enabled
   Menu Add String, hMenuFile, "&Open" + $Tab + "Ctrl-O", %IDM_Open, %MF_Enabled
   Menu Add String, hMenuFile, "&Reload", %IDM_Reload, %MF_Enabled
   Menu Add String, hMenuFile, "-", %IDM_Sep, 0
   Menu Add String, hMenuFile, "&Save" + $Tab + "Ctrl-S", %IDM_Save, %MF_Enabled
   Menu Add String, hMenuFile, "&Save As" + $Tab + "Ctrl-S", %IDM_SaveAS, %MF_Enabled
   Menu Add String, hMenuFile, "-", %IDM_Sep, 0
   Menu Add String, hMenuFile, "E&xit" + $Tab + "Ctrl-X", %IDM_Exit, %MF_Enabled


   'Create Recent + Children -------------------------
   Menu Add PopUp, hMenu, "Re&cent", hMenuRecent, %MF_Enabled, At 2
   Menu Add String, hMenuRecent, "&Clear", %IDM_ClearRecent, %MF_Enabled
   Menu Add String, hMenuRecent, "-", %IDM_Sep, %MF_Enabled
   CreateRecentMenu

   'Create Edit + Children -------------------------
   Menu Add PopUp, hMenu, "&Record", hMenuRecord, %MF_Enabled
   Menu Add String, hMenuRecord, "&Add", %IDM_gridInsertRow, %MF_Enabled
   Menu Add String, hMenuRecord, "&Edit", %IDM_gridEditDialog, %MF_Enabled
   Menu Add String, hMenuRecord, "&Delete", %IDM_gridDeleteRow, %MF_Enabled

   'Create Edit + Children -------------------------
   Menu Add PopUp, hMenu, "&Actions", hMenuSettings, %MF_Enabled
   Menu Add String, hMenuSettings, "&Find", %IDM_Find, %MF_Enabled
   Menu Add String, hMenuSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hMenuSettings, "Fon&t", %IDM_Font, %MF_Enabled
   Menu Add String, hMenuSettings, "&Set Column Widths", %IDM_SetColWidth, %MF_Enabled
   Menu Add String, hMenuSettings, "Sort &Original Data", %IDM_LockSort, %MF_Enabled
   Menu Add String, hMenuSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hMenuSettings, "&UnSort", %IDM_UnSort, %MF_Enabled
   Menu Add String, hMenuSettings, "&ReSort", %IDM_ReSort, %MF_Enabled
   Menu Add String, hMenuSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hMenuSettings, "&True Image Size", %IDM_TrueImageSize, %MF_Enabled
   Menu Add String, hMenuSettings, "&Case Sensitive Sort", %IDM_CaseSensitive, %MF_Enabled

   'Create Edit + Children -------------------------
   Menu Add PopUp, hMenu, "&Help", hMenuHelp, %MF_Enabled
   Menu Add String, hMenuHelp, "&About", %IDM_About, %MF_Enabled

   Menu Attach hMenu, hDlg

End Sub

Sub AddFileNameToRecentFiles
   Local i As Long
   For i = 0 To 9
      If FileName = RecentFiles(i) Then
         Array Delete RecentFiles(i)
         Array Delete RecentWidths(i)
         Exit For
      End If
   Next i
   Array Insert RecentFiles(), FileName
   Array Insert RecentWidths(), ColWidths
End Sub
