'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbgrid.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode=1
#Include "Win32API.inc"

$ver = "3.02"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "icons\gbgrid.ico"
#Resource Icon xenter "icons\down.ico"
#Resource Icon xinplace "icons\inplace.ico"
#Resource Icon xreload "icons\reload.ico"
#Resource Icon xsearch "icons\find.ico"
#Resource Icon xfont "icons\font.ico"
#Resource Icon xcut "icons\cut.ico"
#Resource Icon xcopy "icons\copy.ico"
#Resource Icon xpaste "icons\paste.ico"
#Resource Icon xdelete "icons\delete.ico"
#Resource Icon xundo "icons\undo.ico"
#Resource Icon xsettings "icons\settings.ico"
#Resource Icon xhelp "icons\help.ico"
#Resource Icon xup "icons\sortascending.ico"
#Resource Icon xdown "icons\sortdescending.ico"
#Resource Icon xeyes "icons\eye2.ico"
#Resource Icon xopen "icons\open.ico"
#Resource Icon xsave "icons\save.ico"
#Resource Icon xnosort "icons\nosort.ico"
#Resource Icon xxprint "icons\print.ico"
#Resource Icon xfixed "icons\fixed.ico"
#Resource Icon xdialog "icons\dialog.ico"
#Resource Icon xcanceledit "icons\canceledit.ico"

Enum Equates Singular
   IDC_Toolbar = 500
   IDC_Statusbar
   IDC_LocalHelp
   ID_Timer

   IDT_Open
   IDT_EditInPlace
   IDT_EditFixed
   IDT_EditDialog
   IDT_SaveAs
   IDT_UnSort
   IDT_Cut
   IDT_Copy
   IDT_Paste
   IDT_Delete
   IDT_Undo
   IDT_Reload
   IDT_Find
   IDT_Font
   IDT_Eyes
   IDT_CancelEdit
   IDT_Print
   IDT_Settings
   IDT_Help

   IDM_OnColor
   IDM_OffColor
   IDM_EditColor
   IDM_EnterDown
   IDM_UseColors
   IDM_FixedAlwaysVisible
   IDM_FixedAbove
   IDM_LockSort
   IDM_SetColWidth
   IDM_Sep

   IDM_CancelEdit

   IDM_OnlineIntro
   IDM_OnlineNav
   IDM_OnlineMultiEdit
   IDM_OnlineSingleEdit

   IDM_LocalHelp
   IDM_MonitorFile
   IDM_Test
End Enum

'handles
Global hDlg,hToolbar,hSettings,hHelp  As Dword

'working variables
Global D(), Headers()                 As String
Global DX(), FileDirty                As Long
Global OldFile                        As DirData

'INI variables
Global MonitorFile                    As Long
Global FixedAlwaysVisible, FixedAbove As Long
Global FileName                       As WStringZ * %Max_Path
Global ELeft,ETop,EWidth,EHeight      As Long

#Include "files\gbgrid_sort.inc"
#Include "files\gbgrid_grid.inc"

Function PBMain() As Long
   Dialog Font "Tahoma", 10
   Dialog New Pixels, 0, "gbGrid   v" + $ver,300,100,580,800, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   hDlgG = hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   gbGrid_CreateListView
   gbGrid_CreateEditBoxes
   gbGrid_CreateStatusBar
   Dialog Show Modal hDlg Call DlgProc
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(15)
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd   = %IDM_EnterDown       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E  : ac(c).cmd   = %IDM_gridEdit        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F  : ac(c).cmd   = %IDT_Find            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G  : ac(c).cmd   = %IDM_gridJump        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_I  : ac(c).cmd   = %IDM_gridEditInPlace : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_K  : ac(c).cmd   = %IDM_CancelEdit      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_O  : ac(c).cmd   = %IDT_Open            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P  : ac(c).cmd   = %IDT_Print           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd   = %IDM_gridEditDialog  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd   = %IDT_SaveAs          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd   = %IDM_Test            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W  : ac(c).cmd   = %IDM_SetColWidth     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z  : ac(c).cmd   = %IDT_Undo            : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help            : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F2 : ac(c).cmd   = %IDM_gridEdit        : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd   = %IDT_Find            : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub ManageFixedEditorVisibility
   If FixedAlwaysVisible Or EditMode = %EditFixed Then
      Control Show State hDlg, %IDC_TextBoxF, %SW_Show
   Else
      Control Show State hDlg, %IDC_TextBoxF, %SW_Hide
   End If
End Sub

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   If FixedAlwaysVisible Or EditMode = %EditFixed Then
      'Fixed Editor is visible
      If FixedAbove Then
         'Fixed Editor is at top of page
         Control Set Loc hDlg, %IDC_TextBoxF, 8,65
         Control Set Loc hDlg, %IDC_ListViewG, 10,95
      Else
         'Fixed Editor is at bottom of page
         Control Set Loc hDlg, %IDC_TextBoxF, 8,h - 55
         Control Set Loc hDlg, %IDC_ListViewG, 10, 65
      End If
      Control Set Size hDlg, %IDC_ListViewG, w-20, h-125
      Control Set Size hDlg, %IDC_TextBoxF, w-17,25
   Else
      'Fixed Editor is NOT visible
      Control Set Loc hDlg, %IDC_ListViewG, 10,65
      Control Set Size hDlg, %IDC_ListViewG, w-20, h-95
   End If
   Control ReDraw hDlg, %IDC_StatusBar
End Sub

Sub DisplayLocalHelp
   Local temp$, hMsgBox As Dword, hFontM As Dword, w,h As Long
   temp$ +=  "  Navigate cell by cell" + $CrLf
   temp$ +=  "  Shift-Click/drag to extend boundary of current cell block" + $CrLf
   temp$ +=  "  Control-Click/drag to add additional cell blocks" + $CrLf
   temp$ +=  "  ---" + $CrLf
   temp$ +=  "  Edit in InPlace editor, Fixed Place editor, and Edit Record dialog" + $CrLf
   temp$ +=  "  Set default edit location via Toolbar buttons" + $CrLf
   temp$ +=  "  Fixed Place editor visibility/location are optional" + $CrLf
   temp$ +=  "  Edits show realtime in editors and in the ListView Cell" + $CrLf
   temp$ +=  "  ---" + $CrLf
   temp$ +=  "  F2, Ctl-E, Dbl-Click and ENTER initiate editing at default location" + $CrLf
   temp$ +=  "  Ctl-I initiates editing at InPlace editor" + $CrLf
   temp$ +=  "  Ctl-R open Edit Record dialog" + $CrLf
   temp$ +=  "  Click on fixed editor to edit" + $CrLf
   temp$ +=  "  TAB or shift-TAB to fixed editor to edit" + $CrLf
   temp$ +=  "  ENTER may alternately be used for navigation" + $CrLf
   temp$ +=  "  ---" + $CrLf
   temp$ +=  "  ENTER ends editing" + $CrLf
   temp$ +=  "  ESC, Ctl-K, click outside cell, CancelEdit (Toolbar) cancel editing" + $CrLf
   temp$ +=  "  ---" + $CrLf
   temp$ +=  "  F1    ...  Help" + $CrLf
   temp$ +=  "  F2    ...  Enter Edit Mode" + $CrLf
   temp$ +=  "  F3    ...  Find Dialog" + $CrLf
   temp$ +=  "  Ctl-D ...  Toggle ENTER behavior" + $CrLf
   temp$ +=  "  Ctl-E ...  Enter Edit Mode" + $CrLf
   temp$ +=  "  Ctl-F ...  Find & Replace Dialog" + $CrLf
   temp$ +=  "  Ctl-G ...  GoTo and Select Cell" + $CrLf
   temp$ +=  "  Ctl-I ...  Initiate InPlace Edit" + $CrLf
   temp$ +=  "  Ctl-K ...  Kill (Cancel) Edit" + $CrLf
   temp$ +=  "  Ctl-O ...  Open Existing File" + $CrLf
   temp$ +=  "  Ctl-P ...  Print Selected Cells" + $CrLf
   temp$ +=  "  Ctl-R ...  Open Edit Record Dialog" + $CrLf
   temp$ +=  "  Ctl-S ...  Save As" + $CrLf
   temp$ +=  "  Ctl-W ...  Resize Columns to Fit Content" + $CrLf
   temp$ +=  "  Ctl-Z ...  Undo" + $CrLf

   Font New FontName, FontSize, FontAttr To hFontM

   w = FontSize/10 * 430 : h = 350
   Dialog New Pixels, hDlgG, "Local Help", 25, 25, w,h, %WS_SysMenu To hMsgBox
   Dialog Set Icon hMsgBox, "logo"
   Control Add TextBox, hMsgBox, %IDC_LocalHelp, temp$,10,10, w-20,h-20, %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
                                          Or %WS_HScroll Or %ES_AutoVScroll Or %ES_ReadOnly, %WS_Ex_ClientEdge
   Control Set Font hMsgBox, %IDC_LocalHelp, hFontM
   Control Post hMsgBox, %IDC_LocalHelp, %EM_SetSel, -1, 0
   Dialog Show Modal hMsgBox
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long, xxResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "200", xxResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "200", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xxResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "1000", xxResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xxResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", "", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FindThis", "", FindThis, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ReplaceWithThis", "", ReplaceWithThis, %Max_Path, INIFileName
      Getprivateprofilestring "All", "CopySep", "|", CopySep, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ColWidths", "", ColWidths, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "EditColor", Str$(%rgb_LightYellow), temp, %Max_Path, INIFileName:  EditColor = Val(temp)
      Getprivateprofilestring "All", "OnColor", Str$(%rgb_LightGreen), temp, %Max_Path, INIFileName:  OnColor = Val(temp)
      Getprivateprofilestring "All", "OffColor", Str$(RGB(210,210,210)), temp, %Max_Path, INIFileName:  OffColor = Val(temp)
      Getprivateprofilestring "All", "EnterDown", "1", temp, %Max_Path, INIFileName:  EnterDown = Val(temp)
      Getprivateprofilestring "All", "EditInPlace", "1", temp, %Max_Path, INIFileName:  EditInPlace = Val(temp)
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName: FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "MonitorFile", "0", temp, %Max_Path, INIFileName:  MonitorFile = Val(temp)
      Getprivateprofilestring "All", "UseColors", "1", temp, %Max_Path, INIFileName:  UseColors = Val(temp)
      Getprivateprofilestring "All", "UseEditDialog", "0", temp, %Max_Path, INIFileName:  UseEditDialog = Val(temp)
      Getprivateprofilestring "All", "XTask", "5", temp, %Max_Path, INIFileName:  XTask = Val(temp)
      Getprivateprofilestring "All", "EditMode", "0", temp, %Max_Path, INIFileName:  EditMode = Val(temp)
      Getprivateprofilestring "All", "FixedAlwaysVisible", "1", temp, %Max_Path, INIFileName:  FixedAlwaysVisible = Val(temp)
      Getprivateprofilestring "All", "FixedAbove", "1", temp, %Max_Path, INIFileName:  FixedAbove = Val(temp)

      'get EditDialog info
      Getprivateprofilestring "All", "ELeft", "100", temp, %Max_Path, INIFileName:  ELeft = Val(temp)
      Getprivateprofilestring "All", "ETop", "100", temp, %Max_Path, INIFileName:  ETop = Val(temp)
      Getprivateprofilestring "All", "EWidth", "400", temp, %Max_Path, INIFileName:  EWidth = Val(temp)
      Getprivateprofilestring "All", "EHeight", "600", temp, %Max_Path, INIFileName:  EHeight = Val(temp)

      'custom colors
      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "FindThis",FindThis, INIFileName
      WritePrivateProfileString "All", "ReplaceWithThis",ReplaceWithThis, INIFileName
      WritePrivateProfileString "All", "CopySep",CopySep, INIFileName
      WritePrivateProfileString "All", "ColWidths",ColWidths, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "EditColor", Str$(EditColor), INIFileName
      WritePrivateProfileString "All", "OnColor", Str$(OnColor), INIFileName
      WritePrivateProfileString "All", "OffColor", Str$(OffColor), INIFileName
      WritePrivateProfileString "All", "EnterDown", Str$(EnterDown), INIFileName
      WritePrivateProfileString "All", "EditInPlace", Str$(EditInPlace), INIFileName
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "MonitorFile", Str$(MonitorFile), INIFileName
      WritePrivateProfileString "All", "UseColors", Str$(UseColors), INIFileName
      WritePrivateProfileString "All", "UseEditDialog", Str$(UseEditDialog), INIFileName
      WritePrivateProfileString "All", "XTask", Str$(XTask), INIFileName
      WritePrivateProfileString "All", "EditMode", Str$(EditMode), INIFileName
      WritePrivateProfileString "All", "FixedAlwaysVisible", Str$(FixedAlwaysVisible), INIFileName
      WritePrivateProfileString "All", "FixedAbove", Str$(FixedAbove), INIFileName

      'edit dialog location/position
      WritePrivateProfileString "All", "ELeft", Str$(ELeft), INIFileName
      WritePrivateProfileString "All", "ETop", Str$(ETop), INIFileName
      WritePrivateProfileString "All", "EWidth", Str$(EWidth), INIFileName
      WritePrivateProfileString "All", "EHeight", Str$(EHeight), INIFileName

      'custom colors
      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next x
   End If
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,32,25 To hImageList
    ImageList Add Icon hImageList, "logo"         '1
    ImageList Add Icon hImageList, "xsettings"    '2
    ImageList Add Icon hImageList, "xhelp"        '3
    ImageList Add Icon hImageList, "xreload"      '4
    ImageList Add Icon hImageList, "xenter"       '5
    ImageList Add Icon hImageList, "xinplace"     '6
    ImageList Add Icon hImageList, "xfont"        '7
    ImageList Add Icon hImageList, "xsearch"      '8
    ImageList Add Icon hImageList, "xcut"         '9
    ImageList Add Icon hImageList, "xcopy"        '10
    ImageList Add Icon hImageList, "xpaste"       '11
    ImageList Add Icon hImageList, "xdelete"      '12
    ImageList Add Icon hImageList, "xundo"        '13
    ImageList Add Icon hImageList, "xeyes"        '14
    ImageList Add Icon hImageList, "xopen"        '15
    ImageList Add Icon hImageList, "xsave"        '16
    ImageList Add Icon hImageList, "xnosort"      '17
    ImageList Add Icon hImageList, "xxprint"      '18
    ImageList Add Icon hImageList, "xfixed"       '19
    ImageList Add Icon hImageList, "xdialog"      '20
    ImageList Add Icon hImageList, "xcanceledit"  '21

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 15,  %IDT_Open, %BTNS_Button, "Open"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 16, %IDT_SaveAs, %BTNS_Button, "SaveAs"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Reload, %BTNS_Button, "Reload"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Cut, %BTNS_Button, "Cut"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10, %IDT_Copy, %BTNS_Button, "Copy"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11, %IDT_Paste, %BTNS_Button, "Paste"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12, %IDT_Delete, %BTNS_Button, "Delete"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 13, %IDT_Undo, %BTNS_Button, "Undo"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Find, %BTNS_Button, "Search"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 14, %IDT_Eyes, %BTNS_Button, "Visible"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 17, %IDT_UnSort, %BTNS_Button, "UnSort"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 21, %IDT_CancelEdit, %BTNS_Button, "Cancel"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20

    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_EditInPlace, %BTNS_CheckGroup, "InPlace"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 19,  %IDT_EditFixed, %BTNS_CheckGroup, "Fixed"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 20,  %IDT_EditDialog, %BTNS_CheckGroup, "Dialog"

    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Font, %BTNS_Button, "Font"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 18,  %IDT_Print, %BTNS_Button, "Print"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Help,  %BTNS_Button Or %BTNS_DropDown, "Help"

   'Header context menu
   Menu New PopUp To hSettings
   Menu Add String, hSettings, "Set Focus Color", %IDM_OnColor, %MF_Enabled
   Menu Add String, hSettings, "Set non-Focus Color", %IDM_OffColor, %MF_Enabled
   Menu Add String, hSettings, "Set Edit Color", %IDM_EditColor, %MF_Enabled
   Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "Sort Original Data", %IDM_LockSort, %MF_Enabled
   Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "Enable Colors", %IDM_UseColors, %MF_Enabled
   Menu Add String, hSettings, "ENTER As Down Arrow", %IDM_ENTERDown, %MF_Enabled
   Menu Add String, hSettings, "Monitor File Changes", %IDM_MonitorFile, %MF_Enabled
   Menu Add String, hSettings, "Fixed Editor Always Visible", %IDM_FixedAlwaysVisible, %MF_Enabled
   Menu Add String, hSettings, "Fixed Editor Above Grid", %IDM_FixedAbove, %MF_Enabled

   'Header context menu
   Menu New PopUp To hHelp
   Menu Add String, hHelp, "Local Help", %IDM_LocalHelp, %MF_Enabled
   Menu Add String, hHelp, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hHelp, "Video Tutorial #1 - Introduction", %IDM_OnlineIntro, %MF_Enabled
   Menu Add String, hHelp, "Video Tutorial #2 - Cell Navigation", %IDM_OnlineNav, %MF_Enabled
   Menu Add String, hHelp, "Video Tutorial #3 - Multi-Cell Editing", %IDM_OnlineMultiEdit, %MF_Enabled
   Menu Add String, hHelp, "Video Tutorial #4 - Single Cell Editing", %IDM_OnlineSingleEdit, %MF_Enabled
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_EditInPlace, IIf(EditMode = %EditInPlace,1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_EditFixed, IIf(EditMode = %EditFixed,1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_EditDialog, IIf(EditMode = %EditDialog,1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Undo, IIf(Len(UndoText), %TBState_Enabled, %TBState_Disabled)
   'Menus
    Menu Set State hSettings, ByCmd %IDM_MonitorFile,  IIf(MonitorFIle,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_UseColors,  IIf(UseColors,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_EnterDown,  IIf(EnterDown,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_FixedAlwaysVisible,  IIf(FixedAlwaysVisible,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_FixedAbove,  IIf(FixedAbove,%MFS_Checked,0) Or %MFS_Enabled
End Sub

Sub SaveFileAs
   Local hParent As Dword
   Local title$, folder$, filter$, start$, defaultext$, flags&, filevar$, countvar&
   hParent = hDlg              'if not parent, use 0 or %hWnd_Desktop
   title$ = "Save File As"     'if "", then "Save As" is used
   folder$ = FileName   'if "", Then current directory is used
   filter$ = Chr$("CSV/PSV", 0, "*.csv;*.psv", 0)
   start$ = FileName    'starting filename
   defaultext$ = Right$(FileName,3)
   flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
   Display Savefile hParent, 100, 100, title$, folder$, filter$, start$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then
      FileName = filevar$
      SaveFileName
   End If
End Sub

Sub SaveFileName
    Local iRow, iCol As Long, Sep As String, tmp$, temp$

    Select Case Right$(LCase$(FileName),3)
       Case "psv" : Sep = "|"
       Case "csv" : Sep = ","
       Case "tsv" : Sep = $Tab
    End Select

    'Open file and save data.
    Open FileName For Output As #1

    'Get field names.
    For iCol = 1 To UBound(Headers)
       tmp$ += Headers(iCol) + Sep
    Next i
    tmp$ = Trim$(tmp$,Sep)
    Print #1, tmp$

    'Get records.
    For iRow = 1 To MaxRow
       temp$ = ""
       For iCol = 1 To MaxCol
           If InStr(D(iCol,iRow), Any $Dq + $Cr + Sep) Then
               'Surround with quotes because fields include:
               'double quotes, carriage returns or pipes.
               tmp$ = D(iCol,iRow)
               'Double any double quotes.
               Replace $Dq With $Dq + $Dq In tmp$
               'Replace carriage return line feeds with just line feeds.
               Replace $CrLf With $Lf In tmp$
               temp$ = temp$ + $Dq + tmp$ + $Dq + Sep
           Else
               'No quotes needed.
               temp$ = temp$ + D(iCol,iRow) + Sep
           End If
       Next i
       Print #1, Trim$(temp$,Sep)
    Next lRow
    Close #1
End Sub

Function LoadFileNameToD() As Long
   Local i,iRow,LineSeparator As Long
   Local temp$, pSrc As Byte Ptr
   Local szDst     As AsciiZ * 4096
   Local pDst      As Byte Ptr
   Local lQuote    As Long
   Local lFldCnt   As Long

   'stop monitoring
   KillTimer hDlg, %ID_Timer

   'Open File, get Row and Column Count, Build Array
   Open FileName For Input As #1
   FileScan #1, Records To MaxRow
   If MaxRow < 2 Then
      temp$ = ""
      MaxRow = 1
   Else
      Decr MaxRow
      Line Input #1, temp$
   End If
   Close #1

   'Get ColCount and set line separator
   Select Case Right$(LCase$(FileName),3)
      Case "psv" : MaxCol = ParseCount(temp$,"|")  : LineSeparator = Asc("|")  '124
      Case "csv" : MaxCol = ParseCount(temp$,",")  : LineSeparator = Asc(",")  '44
      Case "tsv" : MaxCol = ParseCount(temp$,$Tab) : LineSeparator = Asc($Tab) '9
   End Select

   'Headers
   ReDim Headers(1 To MaxCol)
   For i = 1 To MaxCol
      Headers(i) = Parse$(temp$,Chr$(LineSeparator),i)
   Next i

   ListView_SetItemCountEx(hListViewG, 0, %LVSICF_noInvalidateAll) 'max rows

   'initialize arrays
   ReDim D(1 To MaxCol ,1 To MaxRow)    '1st row has column header information, not data
   ReDim DX(MaxRow)

   'Open File, get all text
   If Len(temp$) Then
      Open FileName For Binary As #1
      Get$ #1, Lof(1), temp$
      Close #1
   Else
      temp$ = $CrLf + "File Empty"
   End If

   'Remove 1st line because is not data
   i = InStr(temp$,$CrLf)     'end of first line - CRLF required
   temp$ = Mid$(temp$,i+2)   'take out the 1st line
   If Right$(temp$,2) <> $CrLf Then temp$ += $CrLf  'must end in $crlf

   'Load data from file
   pSrc = StrPtr(temp$)
   Do While @pSrc
       Incr iRow
       DX(iRow) = iRow
       szDst = "" : lQuote = 0 : lFldCnt = 0
       pDst = VarPtr(szDst)
       'parse through the next line
       Do While @pSrc
           Select Case @pSrc
               Case 13     'Carriage Return.
                   If lQuote Then
                       'Within quotes, so copy.
                       @pDst = @pSrc
                       Incr pDst
                       Incr pSrc
                       If @pSrc = 10 Then
                           'Copy Line Feed also.
                           @pDst = @pSrc
                           Incr pDst
                           Incr pSrc
                       Else
                           'Add Line Feed anyway.
                           @pDst = 10
                           Incr pDst
                       End If
                   Else
                       'Not within quotes, so end of record.
                       Incr pSrc
                       If @pSrc = 10 Then
                           'Move past line break.
                           Incr pSrc
                       End If
                       'End field.
                       @pDst = %NULL
                       D(lFldCnt+1,iRow) = szDst
                       Exit Do
                   End If

               Case 10     'Line Feed.
                   If lQuote Then
                       'Add Carriage Return before Line Feed.
                       @pDst = 13
                       Incr pDst
                       @pDst = @pSrc
                       Incr pDst
                       Incr pSrc
                   End If

               Case 34     'Double Quote (").
                   lQuote = Not lQuote
                   If lQuote = %FALSE And @pSrc[1] = 34 Then
                       'Next character is also a double quote, so copy one.
                       @pDst = @pSrc
                       Incr pDst
                       Incr pSrc
                       'Skip second double quote.
                       Incr pSrc
                       lQuote = Not lQuote
                   Else
                       'Skip double quote.
                       Incr pSrc
                   End If

               Case LineSeparator
                   If lQuote Then
                       'Within quotes, so copy.
                       @pDst = @pSrc
                       Incr pDst
                       Incr pSrc
                   Else
                       'End of field.
                       @pDst = %NULL
                       D(lFldCnt+1,iRow) = szDst
                       'Prepare for next field.
                       pDst = VarPtr(szDst)
                       'Increment field count.
                       Incr lFldCnt
                       Incr pSrc
                   End If

               Case Else
                   'Copy text.
                   @pDst = @pSrc
                   Incr pDst
                   Incr pSrc
           End Select
       Loop
   Loop

   Dialog Set Text hDlg, "gbGrid   v" + $ver + "     " + FileName
   If MonitorFile Then SetTimer hDlg, %ID_Timer, 1000, ByVal %Null
   temp$ = Dir$(FileName, 0, To OldFile)
   FileDirty = 0
End Function

Sub MonitorFileDate
   Local temp$, tempFile As DirData
   If IsFile(FileName) Then
      temp$ = Dir$(FileName, 0, To tempFile)
      If tempFile.LastWriteTime <> OldFile.LastWriteTime Then
         KillTimer hDlg, %ID_Timer
         Select Case MsgBox ("File has changed. Reload?", %MB_YesNo Or %MB_TaskModal Or %MB_IconExclamation, "File Changed")
            Case %IdYes
               ReloadFileName
            Case %IdNo  'no action
         End Select
         OldFile = tempFile
         SetTimer hDlg, %ID_Timer, 1000, ByVal %Null
      End If
   End If
End Sub

Sub OpenExistingFile(task$)
   Local temp$
   temp$ = FileName
   If task$ = "all" Then
      If SelectFileToLoad = 0 Then Exit Sub  'load file to D(). also, set #columns. 0=no file selected
   End If
   If IsFalse IsFile(FileName) Then Exit Sub
   ListView_SetItemCountEx(hListViewG, 0, %LVSICF_noInvalidateAll) 'max rows
   gbGrid_CreateListView
   LoadFileNameToD
   temp$ = Dir$(FileName, 0, To OldFile)
   If MonitorFile Then SetTimer hDlg, %ID_Timer, 1000, ByVal %Null
   gbGrid_Initialize
   gbGrid_UpdateTextBoxAndStatusBar
   gbGrid_FileSafe
   Control Set Focus hDlg, %IDC_ListViewG
End Sub

Sub ReloadFileName
   gbGrid_CreateListView
   If IsFile(FileName) Then
      OpenExistingFile "noselect"
   Else
      gbGrid_CreateFakeData
      gbGrid_Initialize
      gbGrid_UpdateTextBoxAndStatusBar
      Dialog Set Text hDlg, "gbGrid   v" + $ver
      Control Set Focus hDlgG, %IDC_ListViewG
   End If
End Sub

Function SelectFileToLoad As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Data Files (csv/psv/tsv)" + $Nul + "*.csv;*.psv;*.tsv" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$ + "data")     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       If FileDirty Then    'trap Alt-F4, X-button, WindowMenu/Close
          Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
             Case %IdYes    : SaveFileName : FileName = filevar$ : Function = 1 'continue and save
             Case %IdNo     :                FileName = filevar$ : Function = 1 'continue but not save
             Case %IdCancel : Function = 0                                      'abort the close
          End Select
       Else
          FileName = filevar$ : Function = 1 'continue and save
       End If
    End If
End Function

CallBack Function DlgProc() As Long
   Local nmtb As TBNotify Ptr, PTT As TooltipText Ptr, rc As Rect
   Local temp$, iResult As Long, LVData As NM_ListView
   Local qStart, qStop  As Quad
   Static qFreq As Quad

   Select Case Cb.Msg
      Case %WM_InitDialog
         QueryPerformanceFrequency qFreq
         'steps that do not need INI values
         BuildAcceleratorTable
         If IsFolder (Exe.Path$ + "data") = %False Then MkDir Exe.Path$ + "data"
         'read INI values
         settings_ini "get"
         'load file data or fake data
         If IsFile(FileName) Then
            LoadFileNameToD
            temp$ = Dir$(FileName, 0, To OldFile)
            If MonitorFile Then SetTimer hDlg, %ID_Timer, 1000, ByVal %Null
         Else
            gbGrid_CreateFakeData
         End If
         gbGrid_Initialize
         ManageFixedEditorVisibility
         SetMenusandToolbar
         'prepare to show dialog
         Control Set Focus hDlgG, %IDC_ListViewG
         Dialog Post hDlg, %WM_User+500, 0, 0

      Case %WM_User+500
         If Len(ColWidths) = 0 Then gbGrid_SetColumnWidths
         gbGrid_UpdateTextBoxAndStatusbar

      Case %WM_Timer    : MonitorFileDate
      Case %WM_Destroy
         KillTimer hDlg, %ID_Timer
         gbGrid_Destroy
         settings_ini "save"
      Case %WM_SysCommand
         If ((Cb.WParam And &HFFF0) = %SC_Close) And FileDirty Then    'trap Alt-F4, X-button, WindowMenu/Close
            Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
               Case %IdYes    : SaveFileAs
               Case %IdNo     'go ahead with closing the application
               Case %IdCancel : Function = 1   'abort the close
            End Select
         End If
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_SaveAs          : SaveFileAs
            Case %IDT_Open            : OpenExistingFile "all" : ManageFixedEditorVisibility : ResizeWindow : SetMenusAndToolbar : gbGrid_FileSafe
            Case %IDT_Reload
               If FileDirty Then    'trap Alt-F4, X-button, WindowMenu/Close
                  Select Case gbGrid_MsgBox("File has changed. Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Save File")
                     Case %IdYes      : SaveFileName
                     Case %IdNo       'no action
                     Case %IdCancel   : Function = 0 : Exit Function  'abort the close
                  End Select
               End If
               ReloadFileName : ManageFixedEditorVisibility : ResizeWindow : SetMenusAndToolbar : gbGrid_FileSafe
            Case %IDT_UnSort          : gbGrid_RestoreOriginalOrderTop
            Case %IDT_Font            : gbGrid_Font : gbGrid_SetColumnWidths
            Case %IDT_Find            : gbSearch_DisplaySearchDialog
            Case %IDT_Eyes            : gbGrid_EnsureVisibleCell(CurrentRow, CurrentCol)
            Case %IDT_EditInPlace     : EditMode = %EditInPlace  : ManageFixedEditorVisibility : ResizeWindow : SetMenusAndToolbar
            Case %IDT_EditFixed       : EditMode = %EditFixed    : ManageFixedEditorVisibility : ResizeWindow : SetMenusAndToolbar
            Case %IDT_EditDialog      : EditMode = %EditDialog   : ManageFixedEditorVisibility : ResizeWindow : SetMenusAndToolbar
            Case %IDT_Cut             : gbGrid_GetUndoText   : gbGrid_CutCopyDelete "cut"    : SetMenusAndToolbar
            Case %IDT_Copy            : gbGrid_CutCopyDelete "copy"
            Case %IDT_Paste           : gbGrid_Paste("clipboard") : SetMenusAndToolbar
            Case %IDT_Delete          : gbGrid_GetUndoText   : gbGrid_CutCopyDelete "delete" : SetMenusAndToolbar
            Case %IDT_Undo            : gbGrid_Undo          : SetMenusAndToolbar
            Case %IDT_Settings        : gbGrid_Report
            Case %IDT_Print           : gbGrid_PrintSelectedCells
            Case %IDT_CancelEdit      : gbGrid_CancelEdit  : ResizeWindow
            Case %IDT_Help            : iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbgrid.htm", $Nul, $Nul, %SW_ShowNormal)
            Case %IDC_TextBoxIP       : If Cb.CtlMsg = %EN_Change And GetFocus = hTextBoxIP Then gbGrid_ENChange
            Case %IDC_TextBoxF        : If Cb.CtlMsg = %EN_Change And GetFocus = hTextBoxF  Then gbGrid_ENChange

            Case %IdOk                : gbGrid_IDOK
            Case %IdCancel            : gbGrid_CancelEdit  : ResizeWindow

            Case %IDM_gridJump        : gbGrid_Jump
            Case %IDM_gridVisible     : gbGrid_EnsureVisibleCell(CurrentRow, CurrentCol)
            Case %IDM_gridEdit        : gbGrid_Edit(0)
            Case %IDM_LocalHelp       : DisplayLocalHelp

            Case %IDM_EnterDown       : EnterDown Xor= 1                                     : SetMenusAndToolbar
            Case %IDM_OnColor         : gbGrid_OnColor
            Case %IDM_OffColor        : gbGrid_OffColor
            Case %IDM_EditColor       : gbGrid_EditColor
            Case %IDM_LockSort        : gbGrid_LockSort
            Case %IDM_UseColors       : gbGrid_UseColors     : SetMenusAndToolbar
            Case %IDM_MonitorFile     : MonitorFile Xor=1    : SetMenusAndToolbar
            Case %IDM_FixedAlwaysVisible
               FixedAlwaysVisible Xor= 1 : ManageFixedEditorVisibility : SetMenusAndtoolbar : ResizeWindow
               Dialog ReDraw hDlg
            Case %IDM_FixedAbove
               FixedABove Xor=1             : SetMenusAndtoolbar : ResizeWindow
               Dialog ReDraw hDlg
            Case %IDM_SetColWidth     : gbGrid_SetColumnWidths
            Case %IDM_CancelEdit      : gbGrid_CancelEdit  : ResizeWindow

            Case %IDM_Test            : gbGrid_SetColumnWidths

            Case %IDM_OnlineIntro     : iResult = ShellExecute(hDlg, "Open", "http://youtu.be/dxcKCzTeaJI", $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_OnlineNav       : iResult = ShellExecute(hDlg, "Open", "http://youtu.be/tJO4elxrcjY", $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_OnlineMultiEdit : iResult = ShellExecute(hDlg, "Open", "http://youtu.be/6zBRja2C4lo", $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_OnlineSingleEdit: iResult = ShellExecute(hDlg, "Open", "http://youtu.be/yitWKVLFG4k", $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_gridCut         : gbGrid_CutCopyDelete "cut"
            Case %IDM_gridCopy        : gbGrid_CutCopyDelete "copy"
            Case %IDM_gridDelete      : gbGrid_CutCopyDelete "delete"
            Case %IDM_gridPaste       : gbGrid_Paste "clipboard"
            Case %IDM_gridCutT        : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_gridCopyT       : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_gridPasteT      : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_gridDeleteT     : SendMessage GetFocus, %WM_CLEAR, 0, 0
            Case %IDM_gridDate        : gbGrid_GetUndoText : gbGrid_Modify "date"     : SetMenusAndToolbar
            Case %IDM_gridTime        : gbGrid_GetUndoText : gbGrid_Modify "time"     : SetMenusAndToolbar
            Case %IDM_gridNumber      : gbGrid_GetUndoText : gbGrid_Modify "number"   : SetMenusAndToolbar
            Case %IDM_gridCurrency    : gbGrid_GetUndoText : gbGrid_Modify "currency" : SetMenusAndToolbar
            Case %IDM_gridSum         : gbGrid_Sum
            Case %IDM_gridFillRight   : gbGrid_GetUndoText : gbGrid_FillRight : SetMenusAndToolbar
            Case %IDM_gridFillDown    : gbGrid_GetUndoText : gbGrid_FillDown  : SetMenusAndToolbar
            Case %IDM_gridFillAll     : gbGrid_GetUndoText : gbGrid_FillAll   : SetMenusAndToolbar
            Case %IDM_gridSelectBlockCols   : gbGrid_SelectBlockCols
            Case %IDM_gridInsertBlockCols   : gbGrid_InsertBlockCols
            Case %IDM_gridDeleteBlockCols   : gbGrid_DeleteBlockCols
            Case %IDM_gridSelectBlockRows   : gbGrid_SelectBlockRows
            Case %IDM_gridInsertBlockRows   : gbGrid_InsertBlockRows
            Case %IDM_gridDeleteBlockRows   : gbGrid_DeleteBlockRows
            Case %IDM_gridSelectContextCol  : gbGrid_SelectContextCol
            Case %IDM_gridInsertContextCol  : gbGrid_InsertCol(ContextHeader+1)
            Case %IDM_gridDeleteContextCol  : gbGrid_DeleteCol(ContextHeader+1)
            Case %IDM_gridSetHeaderText     : gbGrid_SetHeaderText
            Case %IDM_gridEditDialog        : gbGrid_DisplayEditDialog
            Case %IDM_gridEditInPlace       : gbGrid_Edit(1)

         End Select
      Case %WM_Size : ReSizeWindow

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDC_ListViewG
               Select Case Cb.NmCode
                  Case %LVN_ItemChanged : gbGrid_ItemChanged(Cb.LParam)
                  Case %LVN_GetDispInfo : gbGrid_GetDispInfo(Cb.LParam)     'notification to ask for data
                  Case %NM_SetFocus     : gbGrid_PaintBlock(0)
                  Case %NM_KillFocus    : gbGrid_PaintBlock(0)
                  Case %NM_CustomDraw   : Function = gbGrid_CustomDraw(Cb.LParam)
                  Case %NM_DblClk       : gbGrid_Edit(0)
                  Case %LVN_ColumnClick
                     QueryPerformanceCounter qStart
                     Type Set LVData = Cb.NmHdr$(SizeOf(LVdata))
                     gbGrid_ColumnClick(LVData.iSubItem+1)
                     QueryPerformanceCounter qStop
                     Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, gbGrid_STitles + "    #Lines: " + Str$(UBound(D,2)) + "    " + Format$((qStop-qStart)/qFreq,"###.000") & " seconds"

               End Select
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Help
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           TrackPopupMenu (hHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
            Case %IDT_Open To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                  PTT = Cb.LParam
                  Select Case Cb.NmId
                     Case %IDT_Open          : @PTT.@lpszText = "Open Existing CSV/PSV File"
                     Case %IDT_SaveAs        : @PTT.@lpszText = "Save As New File Name"
                     Case %IDT_Reload        : @PTT.@lpszText = "Reload File (Loses Edits)"
                     Case %IDT_Cut           : @PTT.@lpszText = "Cut: Copy, then Erase Content of Selected Cells"
                     Case %IDT_Copy          : @PTT.@lpszText = "Copy: Copy Content of Select Cells"
                     Case %IDT_Paste         : @PTT.@lpszText = "Paste: Paste Content at Current Cell"
                     Case %IDT_Delete        : @PTT.@lpszText = "Delete: Erase Content of Selected Cells"
                     Case %IDT_Undo          : @PTT.@lpszText = "Undo Last Cell Cut/Delete/Paste/Insert/Format"
                     Case %IDT_Find          : @PTT.@lpszText = "Open Search & Replace Dialog"
                     Case %IDT_Eyes          : @PTT.@lpszText = "Scroll to Ensure Current Cell Visibility"
                     Case %IDT_UnSort        : @PTT.@lpszText = "Restore to Original Order"
                     Case %IDT_EditInPlace   : @PTT.@lpszText = "EditMode -> Edit Cell Contents in the Cell"
                     Case %IDT_EditFixed     : @PTT.@lpszText = "EditMode -> Edit Cell Contents in the Fixed Editor"
                     Case %IDT_EditDialog    : @PTT.@lpszText = "EditMode -> Edit Cell Contents in Edit Row Dialog"
                     Case %IDT_Font          : @PTT.@lpszText = "Select ListView Font"
                     Case %IDT_CancelEdit    : @PTT.@lpszText = "Cancel Current Edit (Lose Changes)"
                     Case %IDT_Print         : @PTT.@lpszText = "Print All Selected Cells"
                     Case %IDT_Settings      : @PTT.@lpszText = "Display Summary Report"
                     Case %IDT_Help          : @PTT.@lpszText = "Open Online Help Page"
                  End Select
               End Select
         End Select
   End Select
End Function
